//=============================================================================
// KNH_NWS_System.js
//=============================================================================

/*:
 * @plugindesc ローグライクシステム等構築プラグイン
 * @author こんにちは
 *
 * @help がんばってローグライクっぽいシステムを作った
 */

var version = '1.00';

var NWS = function() {
    return $gameSystem.NWS();
};

var _p = function(value) {
    console.log.apply(console, arguments);
    SceneManager.getNwJs().showDevTools();
};

var _rand = function(min,max) {
    return Math.floor(Math.random() * (max + 1 - min)) + min;
};

var _shuffle = function(array) {
     var n = array.length, t, i;
     while (n) {
         i = Math.floor(Math.random() * n--);
         t = array[n];
         array[n] = array[i];
         array[i] = t;
     }
     return array;
};

//ダメージシュミレート用
var NWSDamB = function(atk, def) {return (atk * Math.pow(0.1, def / atk)).clamp(Math.randomInt(2), 999999)};
var NWSSim = function(hp, def) {
    var list = []; for (var i = 0; i < 200; i++) list.push(i);
    list.sort(function(a, b) {
        var _a = (a * Math.pow(0.1, def / a)), _b = (b * Math.pow(0.1, def / b)), _hp = hp / 8;
        return Math.abs(_hp - _a) - Math.abs(_hp - _b);
    })
    return list[0]
};

//デバッグ用
var eventNames = function() {
    return $gameMap ? $gameMap.events().map(function(a){if(a.event()) return a.event().name}).toString() : '';
};

var _lg = function() {
    return $gameVariables ? $gameVariables.value(35) : -1;
};

var _ss = function() {
    (function(){
        var now = (function(n){return(`${n.getFullYear()}${`0${n.getMonth()+1}`.slice(-2)}${`0${n.getDate()}`.slice(-2)}${`0${n.getHours()}`.slice(-2)}${`0${n.getMinutes()}`.slice(-2)}${`0${n.getSeconds()}`.slice(-2)}${`00${n.getMilliseconds()}`.slice(-3)}`)})(new Date());
        var fn = `${document.URL.replace("file:///","").split("index.html")[0]}ss_${now}.png`;
        require('nw.gui').Window.get().capturePage(function(buf){
            require('fs').writeFile(fn,buf,function(e){
                if(e) throw e;
                var mes = `ScreenShot is saved!\n${fn}`
                alert(mes); console.log(mes);
            });
        },{format:'png',datatype:'buffer'});
    })();
};

(function() {
    'use strict';
    var pluginName = 'KNH_NWS_System';
    
    var getNumber = function(text, max, min) {
        text = applyCharacters(text);
        if (isNaN(text)) return NaN;
        return Math.max(Math.min(Number(text), max || Infinity), min || -Infinity);
    };
    
    var applyCharacters = function(text) {
        if (text === null) text = '';
        text = '' + text;
        text = text.replace(/\\/g, '\x1b');
        text = text.replace(/\x1b\x1b/g, '\\');
        text = text.replace(/\x1bV\[(\d+)\]/gi, function() {
            return $gameVariables.value(parseInt(arguments[1], 10));
        }.bind(this));
        text = text.replace(/\x1bV\[(\d+)\]/gi, function() {
            return $gameVariables.value(parseInt(arguments[1], 10));
        }.bind(this));
        text = text.replace(/\x1bN\[(\d+)\]/gi, function() {
            var actor = parseInt(arguments[1], 10) >= 1 ? $gameActors.actor(parseInt(arguments[1], 10)) : null;
            return actor ? actor.name() : '';
        }.bind(this));
        text = text.replace(/\x1bP\[(\d+)\]/gi, function() {
            var actor = parseInt(arguments[1], 10) >= 1 ? $gameParty.members()[parseInt(arguments[1], 10) - 1] : null;
            return actor ? actor.name() : '';
        }.bind(this));
        if ($dataSystem) text = text.replace(/\x1bG/gi, TextManager.currencyUnit);
        return text;
    };
    
    var getMeta = function(text, str) {
        var re = /<([^<>:]+)(:?)([^>]*)>/g;
        var meta = {};
        for (;;) {
            var match = re.exec(text);
            if (match) {
                if (match[2] === ':') {
                    meta[match[1]] = match[3];
                } else {
                    meta[match[1]] = true;
                }
            } else {
                break;
            }
        }
        return meta['' + str];
    };
    
    var rand = function(min,max) {
        return Math.floor(Math.random() * (max + 1 - min)) + min;
    };
    
    //-----------------------------------------------------------------------------
    // 
    //-----------------------------------------------------------------------------
    
    var goldIconIndex = 313;
    var careAnimationId = 4;
    var buffAnimationId = 5;
    var debuffAnimationId = 6;
    
    //-----------------------------------------------------------------------------
    // Game_System
    //-----------------------------------------------------------------------------
    
    Game_System.prototype.NWS = function() {
        if (!this._NWS) this._NWS = {
            _turn               : 0,
            _isShift            : false,
            _equip              : null,
            _weaponsMax         : 16,
            _stocksMax          : 48,
            _weapons            : [],
            _stocks             : [],
            _gettingWeapon      : false,
            _heal               : 3,
            _healsMax           : 10,
            _healPrice          : 10,
            _loseUseable        : false,
            _gotEvents          : [],
            _makeItems          : [],
            _madeItems          : [],
            _books              : [],
            _shopItems          : [],
            _turnExp            : 0,
            _turnGold           : 0,
            _sisterList         : [],
            _weaponsClone       : [],
            _weaponsClone2      : [],
            _shopTotalNum       : 0,
            _shopTotalGold      : 0,
            _levelUpParam       : 0,
            _getSpecial         : false,
            _throwBy            : null,
            _noChangeAtkButton  : false,
            _lastUsedId         : 0,
            _getId              : 0,
            
            _items              : [],
            _itemMax            : 31,
            _equips             : [],
            _explainedItem      : [],
            _lastLevel          : 1,
            _weather            : 0,
            _dark               : false,
            _menuItems          : [],
            _commonEvents       : [],
            _throwing           : false,
            _inputName          : '',
            _choiceCondition    : [],
            _choiceWeapons      : [],
            _displayItem        : null,
            _displayLog         : [],
            _cannotAction      : false,
            _canAction          : false,
            _backCharacter      : [],
            _unlockedMap        : [],
            _cannnotChoiceIndex : [],
            _choiceText         : [],
            _choiceDefault      : -1,
            _displayWeaponPrice : false,
            _displayWeaponArma  : false
        }
        return this._NWS;
    };
    
    Game_System.prototype.isGround = function(x, y) {
        return $gameMap.regionId(x, y) !== 1;
//        return $gameMap.regionId(x, y) === 7 || 
//            ($gameMap.isAirshipLandOk(x, y) && $gameMap.regionId(x, y) !== 1);
    };
    
    //Dイベントを取得 引数にDTypeを入れるとそれに限定
    Game_System.prototype.getAllDEvents = function(t1, t2, t3, t4, t5) {
        var args = Array.prototype.slice.call(arguments);
        return $gameMap.events().filter(function(event) {
            return event._DType && (!arguments.length || args.indexOf(event._DType) >= 0);
        })
    };
    
    //敵(・アクター)の行動順を決定　プレイヤーから距離が近い順　ターゲットが敵のみ最後
    Game_System.prototype.getActionOrder = function() {
//        return [];
        var enemies = this.getAllDEvents(1, 2);
        enemies.sort(function(a, b){
            if (a._target && b._target && a._target != b._target)
                return a._target != $gamePlayer ? 1 : -1;
            var A = a.distanceFrom($gamePlayer), B = b.distanceFrom($gamePlayer);
            return (A < B) ? -1 : (A > B) ? 1 : 0;
        });
        return enemies;
    };
    
    //x,y,dからスキルの効果範囲の[x,y]をすべて取得
    Game_System.prototype.getSkillRange = function(skill, x, y, d) {
        var type = Number(skill.meta.rangeType) || 0;
        var through = Number(skill.meta.through) || 0;
        var list = [], xyList = [], inScreen = false, noSubject = false, all, room, ply;
        if (type === -1) {list = NWS()._attackRange[NWS()._attackIndex]; //プレイヤー攻撃範囲
        } else if (type ===  0) {list = [[0, 0]];
        } else if (type ===  1) {list = [[0, 1]];
        } else if (type ===  2) {list = [[0, 1, 2, 2]];
        } else if (type ===  3) {list = [[0, 1, 2, 3]];
        } else if (type ===  4) {list = [[0, 1, 2, 4]];
        } else if (type ===  5) {list = [[0, 1, 2, 8]];
        } else if (type ===  6) {list = [[-1, 1], [0, 1], [1, 1]];
        } else if (type ===  7) {list = [[-1, 1, 2, 3], [0, 1, 2, 3], [1, 1, 2, 3]];
        } else if (type ===  8) {list = [[-1, 1, 2, 8], [0, 1, 2, 8], [1, 1, 2, 8]];
        } else if (type ===  9) {for (var X = -7; X <= 7; X++) list.push([X, 1, 2, 8]); inScreen = true;
        } else if (type === 10) {list = [[0, 1, 2, 8], [0, -1, 8, 8]];
        } else if (type === 11) {list = [[-1, 0, 4, 8], [1, 0, 6, 8]];
        } else if (type === 12) {list = [[0, 1, 2, 8], [-1, 0, 4, 8], [1, 0, 6, 8], [0, -1, 8, 8]];
        } else if (type === 13) {list = [[0, 1], [-1, 0], [1, 0], [0, -1]];
        } else if (type === 14) {list = [[-1, 1], [-1, -1], [1, -1], [1, 1]];
        } else if (type === 15) {list = [[0, 1], [-1, 1], [-1, 0], [-1, -1], [0, -1], [1, -1], [1, 0], [1, 1]];
        } else if (type === 16) {list = [[-1, 1, 2, 2], [0, 1, 2, 2], [1, 1, 2, 2], [-1, -1, 8, 2], [0, -1, 8, 2], [1, -1, 8, 2],
                                 [-1, 0, 4, 2], [1, 0, 6, 2], [-2, 1], [-2, 2], [-2, -1], [-2, -2],
                                 [2, -1], [2, -2], [2, 1], [2, 2]];
        } else if (type === 17) {for (var X = -7; X <= 7; X++) {for (var Y = -4; Y <= 4; Y++) {
                list.push([X, Y]);
            }}; inScreen = true, noSubject = true;
        } else if (type === 18) {room = true;
        } else if (type === 19) {for (var X = -1; X <= 1; X++) {for (var Y = -1; Y <= 1; Y++) list.push([X, Y])};
        } else if (type === 20) {all = true;
        } else if (type === 21) {
            list = [[0, 1, 2, 6]];
            for (var i = 0; i < 5; i++) list.push([-1 - i, 1 + i]), list.push([1 + i, 1 + i]);
        } else if (type === 22) {list = [[-1, 1, 2, 2], [0, 1, 2, 2], [1, 1, 2, 2]];
        } else if (type === 23) {list = [[-1, 1], [0, 1, 2, 2], [1, 1]];
        } else if (type === 24) {list = [[-1, 1], [0, 1], [1, 1], [-1, 0], [1, 0]];
        } else if (type === 25) {list = [[0, 2, 2, 3]];
        } else if (type === 26) {ply = true;
        } else if (type === 27) {
            list = [[0, 1, 2, 6], [-1, 0, 4, 6], [1, 0, 6, 6], [0, -1, 8, 6]];
            for (var i = 0; i < 5; i++) list.push([-1 - i, 1 + i]), list.push([1 + i, -1 - i]),
                                        list.push([-1 - i, -1 - i]), list.push([1 + i, 1 + i]);
        } else if (type ===  28) {list = [[0, 1, 2, 8]];
        }
        
        if (all) {
            for (var X = 0; X < $dataMap.width; X++) for (var Y = 0; Y < $dataMap.height; Y++)
                if (X !== x || Y !== y) xyList.push([X, Y]);
        } else if (room) {
            if ($gameMap.isRoom(x, y)) {
                var room1 = $gameMap.roomByXY(x, y);
                for (var X = 0; X < $dataMap.width; X++) for (var Y = 0; Y < $dataMap.height; Y++) {
                    var room2 = $gameMap.roomByXY(X, Y);
                    if (!(x === X && y === Y) && room1 === room2) xyList.push([X, Y]);
                }
            } else {
                [[0, 1], [-1, 1], [-1, 0], [-1, -1], [0, -1], [1, -1], [1, 0], [1, 1]].forEach(function(axy) {
                    xyList.push([x + axy[0], y + axy[1]]);
                })
            }
        } else if (ply) {
            xyList.push([$gamePlayer.x, $gamePlayer.y]);
            
        } else {
            var isAll = through === 2 || through === 4;
            list.forEach(function(a) {
                var b = [x, y];
                if (d === 2) b[0] += a[0], b[1] += a[1];
                if (d === 4) b[0] -= a[1], b[1] += a[0];
                if (d === 6) b[0] += a[1], b[1] -= a[0];
                if (d === 8) b[0] -= a[0], b[1] -= a[1];
                if (type === -1) { //プレイヤー通常攻撃の場合
                    if (through >= 3 || $gameSystem.isGround(b[0], b[1])) xyList.push(b.concat([a[2], a[3]]));
                    return;
                }
                if (!a[2]) a[2] = 2, a[3] = 1;
                var d2 = [d, [4, 8, 2, 6][d / 2 - 1], [6, 2, 8, 4][d / 2 - 1], 10 - d][a[2] / 2 - 1];
                for (var i = 0; i < a[3]; i++) {
                    var adx = $gameMap.adjustX(b[0]), ady = $gameMap.adjustY(b[1]);
                    if (inScreen && (adx < 0 || adx >= 15 || ady < 0 || ady >= 9)) {if (isAll) i = a[3]; break;}
                    if (through < 3) {
                        if (!$gameSystem.isGround() ||
                            $gameMap.roomStateDiffer(x, y, b[0], b[1]))
                        {
                            if (!isAll) i = a[3]; break;
                        }
                    }
                    if (!noSubject || b[0] !== x || b[1] !== y) xyList.push([].concat(b));
                    if (through < 1) {
                        if ($gameMap.eventsXy(b[0], b[1]).some(function(event) {
                            return event.isCharacter();
                        })) return;
                        if ($gamePlayer.pos(b[0], b[1])) {if (isAll) i = a[3]; break;}
                    }
                    b[0] += [0, -1, 1, 0][d2 / 2 - 1], b[1] += [1, 0, 0, -1][d2 / 2 - 1];
                }
            })
        }
        return xyList;
    };
    
    //空いているXyを自動で取得
    Game_System.prototype.getFreeXy = function(area, noArea) {
        if (!$gameMap.mapGenerator()) {
            for (var i = 0; i < Math.pow($dataMap.width * $dataMap.height, 1.5); i++) {
                var x = Math.randomInt($dataMap.width), y = Math.randomInt($dataMap.height);
                if ($gameSystem.isGround(x, y)) return [x, y];
            }
            return null;
        }
        var mapGenerator = $gameMap._mapGenerator;
        var targetSymbols = ['room', 'rm1', 'rm2', 'rm3', 'rm4'];
        var targetArea = area || {x:0, y:0, w:$dataMap.width, h:$dataMap.height};
        var canSet = false;
        for (var x = targetArea.x; x < targetArea.x + targetArea.w && !canSet; x++) {
            for (var y = targetArea.y; y < targetArea.y + targetArea.h && !canSet; y ++)
                canSet = (targetSymbols.indexOf($gameMap.symbolXy(x, y)) !== -1);
        }
        if (canSet) {
            for (var i = 0; i < Math.pow(targetArea.w * targetArea.h, 1.5); i++) {
                var x = targetArea.x + Math.randomInt(targetArea.w);
                var y = targetArea.y + Math.randomInt(targetArea.h);
                if ($gameMap.eventsXy(x, y).length === 0 &&
                    targetSymbols.indexOf($gameMap.symbolXy(x, y)) !== -1 &&
                    (!noArea || x < noArea.x || x > noArea.x + noArea.w || y < noArea.y || y > noArea.y + noArea.w) &&
                    !mapGenerator.isAdjacenting(x, y, 'pass'))
                {
                    return [x, y];
                }
            }
        }
        return null;
    };
    
    //ある座標に最も近いXyを自動で取得
    Game_System.prototype.getMostNearXy = function(x, y) {
        for (var i = 1; i < 20; i++) {
            var xy = [];
            for (var X = x - i; X <= x + i; X++) for (var Y = y - i; Y <= y + i; Y++) {
                if ($gameSystem.isGround(X, Y) && !$gamePlayer.pos(X, Y) &&
                    !$gameMap.eventsXy(X, Y).some(function(event) {
                        return event && event.isCharacter();
                    })) xy.push([X, Y]);
            }
            if (xy.length > 0) {
                xy.sort(function(a, b) {
                    return $gameMap.distance(x, y, b[0], b[1]) - $gameMap.distance(x, y, a[0], a[1]);
                    return 1 - Math.randomInt(2) * 2
                });
                return xy[0];
            }
        }
        return null;
    };
    
    //プレイヤーに近いけど視界範囲外で空いているXyを自動で取得
    Game_System.prototype.getFreeXyNearPlayer = function() {
        var d = $gamePlayer._direction;
        var x = $gamePlayer.x + [-7, -10, 10, -7][d / 2 - 1];
        var y = $gamePlayer.y + [7, -3, -3, -6][d / 2 - 1];
        var w = [15, 1, 1, 15][d / 2 - 1];
        var h = [1, 7, 7, 1][d / 2 - 1];
        var xyList = [];
        for (var X = x; X < x + w; X++) for (var Y = y; Y < y + h; Y++) {
            if ($gameMap.isXyFree(X, Y)) xyList.push([X, Y]);
        }
        if (xyList.length) return xyList[Math.randomInt(xyList.length)];
        else return null;
    };
    
    Game_Map.prototype.isXyFree = function(x, y, region60Ok, playerOk) {
        return $gameMap.isValid(x, y) && (x >= 9 || x < $dataMap.width - 9 || y >= 6 || y < $dataMap.height - 6) &&
            (playerOk || !$gamePlayer.pos(x, y)) && !$gamePlayer.isCollidedWithCharacters(x, y) &&
            $gameSystem.isGround(x, y) && $gameMap.isAirshipLandOk(x, y) &&
            (this.regionId(x, y) !== 60 || region60Ok); //リージョン60を除く
    };
    
    Game_Map.prototype.numRegionEnemies = function(regionId, value) {
        if (!regionId) return 0;
        value = value || 0;
        if (!this._numRegionEnemies) this._numRegionEnemies = [];
        if (!this._numRegionEnemies[regionId]) this._numRegionEnemies[regionId] = value;
        else this._numRegionEnemies[regionId] += value;
        this._numRegionEnemies[regionId] = this._numRegionEnemies[regionId].clamp(0, 9);
        return this._numRegionEnemies[regionId];
    };
    
    //行動結果のメッセージを表示
    Game_System.prototype.popResult = function(character, special, damagedBy) {
        var target = character._D;
        var action = (damagedBy && damagedBy._D) ? damagedBy._D.currentAction() : null;
        var display = [], text = '';
        var isActor = target.isActor();
        var byPlayer = (damagedBy && damagedBy.isPlayer() && !character.isPlayer()) ||
                       (NWS()._throwBy && NWS()._throwBy.isPlayer());
        if (target._dead) return;
        //ダメージ
        if (!special && (target.result().missed || target.result().evaded)) { //ミスor回避
            var text = (target.result().missed ? (isActor ? TextManager.actorNoHit : TextManager.enemyNoHit) :
                        TextManager.evasion).format(target.name());
            display.push([text, character, 0, ['hp', null]]);
        } else {
            character._hit = true;
            if (byPlayer) character._turnTowardAfterDamage = true;
            if (byPlayer && ((damagedBy && !damagedBy._usingChildSkill) && !NWS()._throwBy) || (action && action._byThrowingWeapon)) {
                $gamePlayer._hitAttack = true;
//                if ($gameSystem.sisterParam(8) > Math.randomInt(100)) NWS()._loseUseable = true; //武器の耐久値減らす判定
                if (action && action._item && action._item.isItem() && action.item().name.substr(0, 1) !== '_' && !action.item().meta.debug) {
                    var wId = action._item._itemId;
                    if (!NWS()._books[wId]) $gameSystem.pushBooks($gameSystem.newItem(wId));
                    if (!$gameSystem.hasDetail(wId)) $gamePlayer._gotDetails.push(wId);
                }
                
                //ヒット時のテキスト
                var message = action._item.object().meta.message2;
                if (message && !damagedBy._attackMessage2Played && !action._byThrowingWeapon) {
                    var targets = $gameSystem._actionInfo.targets;
                    var t = targets[0]._D.name() + (!_lg() && targets.length > 1 ? 'たち' : '');
                    display.push([_lgCheck(message).format(damagedBy._D.name(), damagedBy.attackItem().itemName(1),
                                                           t),0,0,0,0,'animation']);
                    damagedBy._attackMessage2Played = true;
                }
            }
            if (target.result().hpAffected) {
//                var wait = (target.isDead() || special) ? 1 : null;
                var wait = special ? 1 : null;
                var text = '';
                if (!special) {
                    if (target.result().critical) {
                        display.push([TextManager.criticalToEnemy, character, 38]);
                    }
                    if (byPlayer && target.isEnemy() && target._weak) {
                        text += '\\c[14]%1\\c[0] '.format([
                            '%1の弱点をついた！', 'It’s super effective！', '효과가 굉장했다!',
                            '它超級有效！', '它超级有效！'
                        ][_lg()].format(target.name()));
                    }
                    text += Window_BattleLog.prototype.makeHpDamageText.call(this, target);
                    if (damagedBy) damagedBy._damageTotal += target.result().hpDamage;
                }
                display.push([text, character, 0,
                              ['hp', target.result().hpDamage, target.result().critical],
                              target.result().hpDamage > 0 ? 'damage' : null, wait]);
            }
            if (target.result().mpDamage) {
                var wait = special ? 1 : null;
                display.push([!special ? Window_BattleLog.prototype.makeMpDamageText.call(this, target) : '',
                              character, 0,
                              ['mp', target.result().mpDamage, target.result().critical],
                              target.result().mpDamage > 0 ? 'damage' : null, wait]);
            }
        }
        NWS()._throwBy = null;
        target._weak = target._resist = false;
        //死亡
        if (target.metaState('immortality') || (special && target.isActor()))
            target._hp = Math.max(target.hp, 1);
        var deadState = byPlayer && target.isDeathStateAffected(); //即死
        if (deadState) {
            display.push(['', character, 116]);
            this.popEffectMessage(character, damagedBy, display);
            text = ['%1の息の根を止めた！', 'Immediate death effect was activated to %1!', '%1 즉사 효과가 발동했다!',
                    '立即死亡效應被激活為%1！', '立即死亡效应被激活为%1！'][_lg()].format(target.name());
        }
        if (target.hp <= 0 || deadState) {
            target._reviving = !!(target.metaState('kago') || target._event.metaItem('kago'));
            if (!deadState) text = ['%1は倒れた！', '%1 is defeated!', '%1는 쓰러졌다!', '%1已經被殺！', '%1已经被杀！'][_lg()].format(target.name());
            if (target.isEnemy() && !target._reviving && (!damagedBy || byPlayer)) { //経験値・お金獲得
                var exp = target.enemy().exp; //経験値
                exp *= 1 + $gamePlayer._D.metaStateNum('expPlusRate');
                exp *= $gameSystem.sisterParam(0);
                exp *= Math.pow(character._powerUp || 1, 1.5);
                exp = Math.round(exp);
//                text += ' EXP +%1'.format(exp);
                character._exp = exp;
                var gold = Math.round(target.enemy().gold * _rand(5, 15) / 10);
                character._gold = gold;
            }
            display.push([text, character, null, null, 'dead']);
            target._dead = true;
        }
        
        if (!target._dead) {
            //ステート
            if (target.result().isStatusAffected()) {
                this.popEffectMessage(character, damagedBy, display);
                target.result().addedStateObjects().forEach(function(state) { //ステートにかかった
                    var text = target.isActor() ? state.message1 : state.message2;
                    if (text) display.push([target.name() + _lgCheck(text), character, Number(state.meta.animation)]);
                    //アイテム_stateGuard
                    if (state.meta.stateGuard && target._event.metaItem('stateGuard')) {
                        var item = target._event.metaItem('stateGuard');
                        target._event.useSkill(13, item);
                    }
                }, this);
                target.result().removedStateObjects().forEach(function(state) { //ステート治った
                    if (state.message4) display.push([target.name() + _lgCheck(state.message4), character, careAnimationId]);
                }, this);
            }
            //バフ
            this.popBuffs(character, target.result().addedBuffs, TextManager.buffAdd, display, buffAnimationId, damagedBy);
            this.popBuffs(character, target.result().addedDebuffs, TextManager.debuffAdd, display, debuffAnimationId, damagedBy);
            this.popBuffs(character, target.result().removedBuffs, TextManager.buffRemove, display, careAnimationId, damagedBy);
        }
        
        for (var i = 0; i < display.length; i++) {
            var d = display[i];
            $gameSystem.display(d[0], d[1], d[2], d[3], d[4], d[5]);
        }
    };
    Game_System.prototype.popBuffs = function(character, buffs, fmt, display, animationId, damagedBy) {
        buffs.forEach(function(paramId) {
            this.popEffectMessage(character, damagedBy, display);
            display.push([fmt.format(character._D.name(), TextManager.param(paramId)), character, animationId]);
        }, this);
    };
    Game_System.prototype.popEffectMessage = function(character, damagedBy, display) {
        if (!damagedBy) return;
        var action = damagedBy._D.currentAction();
        if (damagedBy && damagedBy.isPlayer() && !character.isPlayer() &&
            !damagedBy._usingChildSkill && !damagedBy._attackMessage3Played) {
            var message = action._item.object().meta.message3;
            if (message) {
                var targets = $gameSystem._actionInfo.targets;
                var t = !targets[0]._D ? ['相手', 'Enemiey', '적', '敵人', '敌人'][_lg()] : (targets[0]._D.name() + (!_lg() && targets.length > 1 ? 'たち' : ''));
                display.push([_lgCheck(message).format(damagedBy._D.name(), action._item.itemName(1), t)]);
                damagedBy._attackMessage3Played = true;
            }
        }
    };
    
    //マップの(0,0)イベントからモンスター設定を読みこみ、エネミーIDをランダムで自動取得
//    Game_System.prototype.randomEnemyId = function() {
//        var idList = [];
//        var page = ($dataMap.events.filter(function(event) {
//            return (!!event && event.x === 0 && event.y === 0);
//        }, this))[0].pages[0];
//            for (var i = 0; i < page.list.length; i++) {
//                var params = page.list[i].parameters;
//                if (page.list[i].code === 355 || page.list[i].code === 655) {//スクリプト
//                    var array = eval(params[0]);
//                    for (var j = 0; j < array[1]; j++) idList.push(array[0]);
//                }
//            }
//        return idList[Math.randomInt(idList.length)];
//    };
    
    //マップmetaに<settingByEvent>が入っていた場合
    //マップの(0,0)イベントからマップ設定を読みこみ、アイテム・防具IDをランダムで自動取得
//    Game_System.prototype.randomItemId = function(type) {
//        if (!$dataMap.meta.settingByEvent) return this.randomItemIdByData(type);
//        var idList = [];
//        var pages = ($dataMap.events.filter(function(event) {
//            return (!!event && event.x === 0 && event.y === 0);
//        }, this))[0].pages;
//        pages.forEach(function(page) {
//            for (var i = 0; i < page.list.length; i++) {
//                var params = page.list[i].parameters;
//                if ((!type || type === 1) && page.list[i].code === 126) { //アイテム
//                    for (var j = 0; j < params[3]; j++) idList.push(params[0]);
//                } else if ((!type || type === 2) && page.list[i].code === 128) { //防具
//                    for (var j = 0; j < params[3]; j++) idList.push(params[0]);
//                }
//            }
//        }, this);
//        return idList[Math.randomInt(idList.length)];
//    };
    
    //x,y にアイテムイベントを設置
    Game_System.prototype.putItem = function(item, x, y, throwDirection, through, speed) {
        var id = 97;
        if (id) {
            var args = {D : item};
            if (throwDirection) args.throw = true, args.throwInfo = [throwDirection, through, speed];
            else args.jump = true;
            $gameMap.spawnEvent(id, x, y, true, args);
            $gameMap.rejudgeEvents();
        }
    };
    
    //x,y に敵を配置
    Game_System.prototype.bornEnemy = function(enemyId, x, y, regionId) {
        var id = Game_Interpreter.prototype.getEventIdForEventReSpawn.call({_eventId:-1}, 'enemy' + enemyId, true);
        $gameMap.spawnEvent(id, x, y, true, {regionId : regionId});
        $gameMap.rejudgeEvents();
        $gameMap.numRegionEnemies(regionId, 1);
    };
    //x,y にアイテムを配置
    Game_System.prototype.bornItem = function(x, y) {
        var id = !Math.randomInt(5) ? 6 : !Math.randomInt(5) ? 5 : 4; //道具かアイテムかお金か
        $gameMap.spawnEvent(id, x, y, true, {jump : true});
    };
    
    //x,y に会話・調べるが可能なオブジェクトがあるかどうか
    Game_System.prototype.areTriggerEventsXy = function(x, y) {
        $gamePlayer._testTriggerEvents = true;
        var event = $gamePlayer.startMapEvent(x, y, [0], true);
        $gamePlayer._testTriggerEvents = false;
        return event && !event.event().meta.noTrg && !event._attackMode && !event.roomStateDiffer($gamePlayer) &&
            !(event.event().meta.startDirection && Number(event.event().meta.startDirection) !== $gamePlayer._direction);
    };
    
    //アイテムがいっぱいかどうか
    Game_System.prototype.itemMax = function() {
        return NWS()._items.length >= NWS()._itemMax;
    };
    
    //所持武器がいっぱいかどうか
    Game_System.prototype.weaponsMax = function() {
        for (var i = 0; i < NWS()._weaponsMax; i++) {
            if (!NWS()._weapons[i]) return false;
        }
        return true;
    };
    
    //倉庫がいっぱいかどうか
    Game_System.prototype.stocksMax = function() {
        NWS()._stocksMax = $gameSystem.sisterParam(1);
        return NWS()._stocks.length >= NWS()._stocksMax;
    };
    
    //新規アイテムを作成
    Game_System.prototype.newItem = function(itemId) {
        if (!$dataItems[itemId]) return null;
        var item = new Game_Item();
        item.setObject($dataItems[itemId]);
        return item;
    };
    //新規防具を作成
    Game_System.prototype.newArmor = function(itemId) {
        var item = new Game_Item();
        item.setObject($dataArmors[itemId]);
        return item;
    };
    //新規お金を作成
    Game_System.prototype.newGold = function(gold) {
        var item = new Game_Item();
        item._gold = gold || 1;
        return item;
    };
    
    //全装備を修理
    Game_System.prototype.repairAllEquips = function() {
        NWS()._equips.forEach(function(item) {
            item.repair();
        })
    };
    
    //演出リクエスト
    Game_System.prototype.display = function(text, target, animationId, popup, motion, wait) {
        SceneManager._scene._displayOrder.push([text, target, animationId, popup, motion, wait]);
    };
    Game_System.prototype.displayUnshift = function(text, target, animationId, popup, motion, wait) {
        SceneManager._scene._displayOrder.unshift([text, target, animationId, popup, motion, wait]);
    };
    //演出SEを設定
    Game_System.prototype.setDisplaySe = function(type) {
        SceneManager._scene._displayOrder.push(['SE', type]);
    };
    Game_System.prototype.setDisplaySeUnshift = function(type) {
        SceneManager._scene._displayOrder.unshift(['SE', type]);
    };
    
    //メッセージ履歴に追加
    Game_System.prototype.pushDisplayLog = function(text) {
        NWS()._displayLog.push(text);
        while (NWS()._displayLog.length > 30) NWS()._displayLog.shift();
    };
    
    //busy
    Game_System.prototype.isBusy = function() {
        var scene = SceneManager._scene;
//        return $gameMap.isEventRunning() || 
//            scene._messageWindow.isOpen() ||
//            scene.isBusy() || SceneManager.isSceneChanging() || $gameTemp._continuing;
        return $gameTemp._continuing;
    };
    
    //演出待ち
    Game_System.prototype.isDisplayWaiting = function() {
        return SceneManager._scene._displayCount > 0 || SceneManager._scene._displayOrder.length;
    };
    
    //アニメ再生待ち
    Game_System.prototype.isAnimationPlaying = function() {
        var value = !SceneManager._scene._spriteset._playAnimationSprite.isFinishAnimation() ||
        ([$gamePlayer].concat($gameSystem.getAllDEvents(1))).some(function(character) {
            return !character.needNotUpdate() && character.isAnimationPlaying();
        });
        if (value) {
            if (this._animationPlayingCount >= 60 * 5) {
                this._animationPlayingCount = -1;
                return false;
            } else {
                if (this._animationPlayingCount < 0) this._animationPlayingCount = 0;
                return value;
            }
        } else {
            this._animationPlayingCount = -1;
            return value;
        }
    };
    
    //投げ待ち
    Game_System.prototype.isThrowing = function() {
        return !!NWS()._throwing;
    };
    //空飛んでる
    Game_System.prototype.isFlying = function() {
        return $gameSwitches.value(33);
    };
    
    //誰かしらが移動を行っている
    Game_System.prototype.isMoving = function(noJump) {
//        return ([$gamePlayer].concat($gameMap.events())).some(function(character) {
//            return character.isCharacter() && !character.needNotUpdate() &&
//                (character.isMoving() || (!noJump && character.isJumping()));
//        })
        return ([$gamePlayer].concat($gamePlayer._targets)).some(function(character) {
            return character.isCharacter() && !character.needNotUpdate() &&
                (character.isMoving() || (!noJump && character.isJumping()));
        })
    };
    
    //誰かしらがアクションを行っている
    Game_System.prototype.isActionPlaying = function() {
        return $gameSwitches.value(2) ||
            $gameSystem.isDisplayWaiting() || $gameSystem.isThrowing();
    };
    
    //アクションが予約されている
    Game_System.prototype.isActionReserved = function() {
        return !!SceneManager._scene._reservedActions.length;
    };
    
    //アクション開始が可能かどうか
    Game_System.prototype.canAction = function() {
        return $gameSystem.canMove() && !$gameSystem.isMoving();
    };
    //行動可能かの判定を更新
    Game_System.prototype.updateCanAction = function() {
        NWS()._canAction = $gameSystem.canAction();
    };
    
    //移動が可能かどうか
    Game_System.prototype.canMove = function() {
        return !$gameSystem.isBusy() && !$gameSystem.isActionPlaying() &&
            !$gameSystem.isActionReserved() && !$gameSwitches.value(3) &&
            !$gameSystem.isExpPlaying();
    };
    
    //空を飛ぶが可能かどうか
    Game_System.prototype.canFly = function() {
        return !!NWS()._equip && !$gameSystem.inRoom() && !$gameSwitches.value(18) &&
            $dataMap.meta && !$dataMap.meta.Dungeon && !$dataMap.meta.noFly && !$dataMap.meta.SBI &&
            ($gamePlayer.attackItem().object().meta.canFly || $gameSwitches.value(32));
    };
    
    //rect範囲内にカーソルがあるか
    Game_System.prototype.touchRect = function(x, y, w, h) {
        var tx = TouchInput.x, ty = TouchInput.y;
        return tx >= x && ty >= y && tx < x + w && ty < y + h;
    };
    
    //アイテムをソート
    Game_System.prototype.sortItems = function(items, type) {
        if (type === 0) { //番号順
            items.sort(function(a, b) {
                if (!a || !b) return !b ? -1 : !a ? 1 : 0;
                if (a.itemId() !== b.itemId()) return a.itemId() - b.itemId() //アイテムID順
                if (a._useable !== b._useable) return b._useable - a._useable; //耐久値は多い順
                return 0;
            })
        } else if (type === 1) { //名前順
            var katakanaToHiragana = function(src) {
                return src.replace(/[\u30a1-\u30f6]/g, function(match) {
                    var chr = match.charCodeAt(0) - 0x60;
                    return String.fromCharCode(chr);
                });
            }
            items.sort(function(a, b) {
                if (!a || !b) return !b ? -1 : !a ? 1 : 0;
                a = katakanaToHiragana(a.reading());
                b = katakanaToHiragana(b.reading());
                if (a < b) return -1;
                else if (a > b) return 1;
                return 0;
            })
        } else if (type === 2) { //使用順
            items.sort(function(a, b) {
                if (!a || !b) return !b ? -1 : !a ? 1 : 0;
                a._lastUsedId = a._lastUsedId || 0, b._lastUsedId = b._lastUsedId || 0;
                if (a._lastUsedId !== b._lastUsedId) return b._lastUsedId - a._lastUsedId; //アイテムID順
                return 0;
            })
        } else if (type === 3) { //入手順
            items.sort(function(a, b) {
                if (!a || !b) return !b ? -1 : !a ? 1 : 0;
                a._getId = a._getId || 0, b._getId = b._getId || 0;
                if (a._getId !== b._getId) return b._getId - a._getId; //アイテムID順
                return 0;
            })
        } else if (type === 4) { //威力順
            items.sort(function(a, b) {
                if (!a || !b) return !b ? -1 : !a ? 1 : 0;
                var ad = !!$gameSystem.hasDetail(a.itemId()), bd = !!$gameSystem.hasDetail(b.itemId());
                if (ad !== bd) return ad ? -1 : 1;
                if (a.power() !== b.power()) return b.power() - a.power();
                if (a.itemId() !== b.itemId()) return a.itemId() - b.itemId(); //アイテムID順
                if (a._useable !== b._useable) return b._useable - a._useable; //耐久値は多い順
                return 0;
            })
        }
    };
    
    //料理
    Game_System.prototype.cook = function(item, type) {
        if (!item) return;
        var list = [], meta = item.object().meta;
        if (!type || type === 1) list = list.concat(meta.cookType1 ? meta.cookType1.split(',') : []);
        if (!type || type === 2) list = list.concat(meta.cookType2 ? meta.cookType2.split(',') : []);
        if (!type || type === 3) list = list.concat(meta.cookType3 ? meta.cookType3.split(',') : []);
        var id = Number(list[Math.randomInt(list.length)]);
        if (id) {
            $gamePlayer.eraseItem(item);
            var item2 = this.newItem(id);
            $gamePlayer.getItem(item2);
            return item2;
        }
        return;
    };
    //調合
    Game_System.prototype.mix = function(items, iconIndex, useable, ev) {
        if (!items || items.length < 2) return;
        var item = this.newItem(ev ? 195 : 11);
        item._children = [];
        for (var i = 0; i < items.length; i++) 
            items[i]._mixed = true, item._children.push(items[i]);
        if (iconIndex) item._iconIndex = iconIndex;
        item._useable = useable || 2;
        for (var i = 0; i < items.length; i++) $gamePlayer.eraseItem(items[i]);
        if (!ev) $gamePlayer.getItem(item);
        return item;
    };
    
    //行動中のキャラ
    Game_System.prototype.acting = function() {
        return SceneManager._scene._acting || null;
    };
    
    //shift中はDestinationをセットしない
    var _Game_Temp_setDestination = Game_Temp.prototype.setDestination;
    Game_Temp.prototype.setDestination = function(x, y) {
        if (NWS()._isShift) return;
        if ($gameVariables.value(9) === 5) return; //チュートリアル
        _Game_Temp_setDestination.apply(this, arguments);
    };
    
    //武器名から武器IDを取得
    Game_System.prototype.getWeaponIdByName = function(name) {
        if (Number(name)) return Number(name);
        var id = 0;
        $dataItems.some(function(weapon) {
            if (weapon && weapon.name === name) {
                id = weapon.id;
                return true;
            }
        })
        return id;
    };
    //スキル名からスキルIDを取得
    Game_System.prototype.getSkillIdByName = function(name) {
        var id = 0;
        $dataSkills.some(function(skill) {
            if (skill && skill.name === name) {
                id = skill.id;
                return true;
            }
        })
        return id;
    };
    
    //拾ったイベントのイベントID・マップIDをリストに登録
    Game_System.prototype.pushGotEvents = function(item, event, value) {
        var itemId = item._itemId;
        if (!itemId || !event || event.isPrefab() ||
            (!event._NPC && event._DType === 1)) return; //プレハブイベントは無限に入手できるので登録しない、敵は再登場させない
        if (item.object().meta.alwaysInStock) return; //データベースに記載の場合も
//        if (!NWS()._gotEvents[itemId]) NWS()._gotEvents[itemId] = [];
//        var info = NWS()._gotEvents[itemId];
//        info.push(value);
        item._code = value;
    };
    //イベント復活
    Game_System.prototype.revivalGotEvent = function(item) {
        if ($dataMap.meta.SBI) return;
        if ($dataMap.meta.maojo) {
            if (NWS()._weaponsClone2.contains(item)) return;
        }
        if (item._noRevival) return;
        if (item._code) {
            $gameSelfSwitches.setValue(item._code, false);
        } else {
            $gameSystem.addMakeItem(item._itemId, 1);
        }
    };
    
    //図鑑に登録
    Game_System.prototype.pushBooks = function(item) {
        if (!item || NWS()._books[item._itemId]) return;
        NWS()._books[item._itemId] = $gameSystem.newItem(item._itemId);
    }
    
    //図鑑データを返す
    Game_System.prototype.booksData = function() {
        var data = [];
        var dataItems = [].concat($dataItems).filter(function(item) {
            return item && item.name && item.name.substr(0, 1) !== '_' && !item.meta.debug;
        })
        dataItems.sort(function(a, b) {
            return (Number(a.meta.itemId) || a.id) - (Number(b.meta.itemId) || b.id);
        }); 
        dataItems.forEach(function(item) {
            data.push(NWS()._books[item.id] || null);
        }, this)
        return data;
    }
    //図鑑完成率
    Game_System.prototype.booksRate = function() {
        var num = NWS()._books.filter(function(item) {return !!item && item._detail}).length / this.booksData().length * 100;
        return num.toFixed(1);
    }
    //itemIdの武器を一度でも入手済みか
    Game_System.prototype.hasGot = function(itemId) {
        return NWS()._books[itemId] && !!NWS()._books[itemId]._got;
    }
    //itemIdの武器の詳細を解禁しているか
    Game_System.prototype.hasDetail = function(itemId) {
        return NWS()._books[itemId] && !!NWS()._books[itemId]._detail;
    }
    
    //鍛冶屋にアイテムを入荷
    Game_System.prototype.setMakeItem = function(itemId) {
        var num = Number($dataItems[itemId].meta.initMakeNum);
        NWS()._makeItems[itemId] = (num || num === 0) ? num : 3;
    };
    //鍛冶屋在庫の増減
    Game_System.prototype.addMakeItem = function(itemId, value) {
        if (!NWS()._makeItems[itemId]) NWS()._makeItems[itemId] = 0;
        var num = NWS()._makeItems[itemId];
        num = ((num || 0) + (value || 1)).clamp(0, 9) || 1;
        NWS()._makeItems[itemId] = num;
        
    }
    
    //オートタイル機能実装
    var tileIdsFloor = {};
    tileIdsFloor.candidate =
        [ 0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11,
         12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23,
         24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35,
         36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47];
    tileIdsFloor.connect = {
        1:[ 0,  1,  2,  3,  4,  5,  6,  7, 16, 17, 18, 19,
           20, 21, 24, 26, 28, 29, 30, 31, 32, 33, 34, 35,
           36, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47],         // 1:左下
        2:[ 0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11,
           12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23,
           24, 25, 26, 27, 32, 34, 35, 36, 37, 42, 47],         // 2:下
        3:[ 0,  1,  2,  3,  8,  9, 10, 11, 16, 17, 20, 22,
           24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 36,
           37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47],         // 3:右下
        4:[ 0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11,
           12, 13, 14, 15, 20, 21, 22, 23, 24, 25, 26, 27,
           28, 29, 30, 31, 33, 36, 37, 38, 39, 45, 47],         // 4:左
        6:[ 0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11,
           12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23,
           28, 29, 30, 31, 33, 34, 35, 40, 41, 43, 47],         // 6:右
        7:[ 0,  2,  4,  6,  8, 10, 12, 14, 16, 17, 18, 19,
           20, 21, 22, 23, 24, 25, 28, 30, 32, 33, 34, 35,
           36, 37, 38, 40, 41, 42, 43, 44, 45, 46, 47],         // 7:左上
        8:[ 0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11,
           12, 13, 14, 15, 16, 17, 18, 19, 24, 25, 26, 27,
           28, 29, 30, 31, 32, 38, 39, 40, 41, 44, 47],         // 8:上
        9:[ 0,  1,  4,  5,  8,  9, 12, 13, 16, 18, 20, 21,
           22, 23, 24, 25, 26, 27, 28, 29, 32, 33, 34, 35,
           36, 37, 38, 39, 40, 42, 43, 44, 45, 46, 47]          // 9:右上
    };
    tileIdsFloor.noConnect = {
        1:[ 8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19,
           22, 23, 25, 27, 28, 29, 30, 31, 32, 33, 34, 35,
           37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47],         // 1:左下
        2:[28, 29, 30, 31, 33, 38, 39, 40, 41, 43, 44, 45, 46], // 2:下
        3:[ 4,  5,  6,  7, 12, 13, 14, 15, 18, 19, 21, 23,
           24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 35, 36,
           37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47],         // 3:右下
        4:[16, 17, 18, 19, 32, 34, 35, 40, 41, 42, 43, 44, 46], // 4:左
        6:[24, 25, 26, 27, 32, 36, 37, 38, 39, 42, 44, 45, 46], // 6:右
        7:[ 1,  3,  5,  7,  9, 11, 13, 15, 16, 17, 18, 19,
           20, 21, 22, 23, 26, 27, 29, 31, 32, 33, 34, 35,
           36, 37, 39, 40, 41, 42, 43, 44, 45, 46, 47],         // 7:左上
        8:[20, 21, 22, 23, 33, 34, 35, 36, 37, 42, 43, 45, 46], // 8:上
        9:[ 2,  3,  6,  7, 10, 11, 14, 15, 17, 19, 20, 21,
           22, 23, 24, 25, 26, 27, 30, 31, 32, 33, 34, 35,
           36, 37, 38, 39, 41, 42, 43, 44, 45, 46, 47]          // 9:右上
    };

    Game_System.prototype.setAutoTileId = function(x, y, z, tileId) {
        var getBaseTileId = function(kind) {
            return kind * 48 + 2048;
        }
        var getTileKind = function(tileId) {
            return Tilemap.isAutotile(tileId) ? Math.floor((tileId - 2048) / 48) : tileId;
        }
        
        var dataId = (z * $dataMap.height + y) * $dataMap.width + x;
        var baseTileId = tileId || (z === 0 ? Number($dataMap.meta.baseTileId) || 2816 : 0);
        if (!Tilemap.isAutotile(baseTileId) || !Tilemap.isGroundTile(baseTileId)) { 
            $dataMap.data[dataId] = baseTileId;
        } else {
            baseTileId += !tileId ? 46 : 0;
            $dataMap.data[dataId] = baseTileId;
        }
        [1, 2, 3, 4, 6, 7, 8, 9].forEach (function(d) {
            var x2 = x + Math.floor((d - 1) % 3) - 1, y2 = y - Math.floor((d - 1) / 3) + 1;
            var dataId2 = (z * $dataMap.height + y2) * $dataMap.width + x2;
            var baseTileId2 = $dataMap.data[dataId2];
            if (!Tilemap.isAutotile(baseTileId2) || !Tilemap.isGroundTile(baseTileId2)) return;
            var candidateTileIds = [].concat(tileIdsFloor.candidate);
            [1, 2, 3, 4, 6, 7, 8, 9].forEach (function(direction) {
                var dx = x2 + Math.floor((direction - 1) % 3) - 1, dy = y2 - Math.floor((direction - 1) / 3) + 1;
                var roundDataId = (z * $dataMap.height + dy) * $dataMap.width + dx;
                var roundTileId = $dataMap.data[roundDataId];
                if ((dx < 0 || dx >= $dataMap.width) || (dy < 0 || dy >= $dataMap.height)) {
                    return; // マップ範囲外なら判定しない
                }
                if (Tilemap.isSameKindTile(baseTileId2, roundTileId)) {
                    candidateTileIds = candidateTileIds.filter(function(Id) {
                        return tileIdsFloor.connect[direction].contains(Id);
                    }); // 同種オートタイルの場合候補タイルIDから接続タイルIDを選択
                } else {
                    candidateTileIds = candidateTileIds.filter(function(Id) {
                        return tileIdsFloor.noConnect[direction].contains(Id);
                    }); // 異種オートタイルの場合候補タイルIDから非接続タイルIDを選択
                }
            }, this);
            $dataMap.data[dataId2] = getBaseTileId(getTileKind(baseTileId2)) + (candidateTileIds[0] || 0);
        }, this);
    };
    
    Game_System.prototype.getMostNearRegionId = function(x, y) {
        if (!$gameMap._regionList || $gameMap.mapId() !== $gameMap._lastMapId) {
            $gameMap._lastMapId = $gameMap.mapId();
            $gameMap._regionList = [];
            for (var X = 0; X < $dataMap.width; X++) for (var Y = 0; Y < $dataMap.height; Y++) {
                var regionId = $gameMap.regionId(X, Y);
                if (regionId >= 61 && regionId < 81) $gameMap._regionList.push([X, Y, regionId]);
            }
        }
        var rList = $gameMap._regionList.sort(function(a, b) {
            var dA = Math.sqrt(Math.pow(a[0] - x, 2) + Math.pow(a[1] - y, 2));
            var dB = Math.sqrt(Math.pow(b[0] - x, 2) + Math.pow(b[1] - y, 2));
            return dA - dB;
        });
        return rList.length ? rList[0][2] : 0;
    }
    
    Game_System.prototype.encountEnemyId = function(regionId) {
        if (!$gameMap._encount || !regionId || regionId < 61 || regionId >= 81) return 0;
        var info = $gameMap._encount[regionId];
        if (!info) return 0;
        var denom = info.denom * (1 + ($gameMap.numRegionEnemies(regionId) * 2 - 10) / 10);
        if ($gameMap.numRegionEnemies(regionId) > 4) denom *= 3;
        if (!info || Math.randomInt(denom) || !info.enemyList.length) return 0;
        var list = [];
        info.enemyList.forEach(function(enc) {
            for (var i = 0; i < enc[1]; i++) list.push(enc[0]);
        })
        return list[Math.randomInt(list.length)] || 0;
    };
    
    Game_System.prototype.arma = function() {
        return $gameVariables.value(8);
    };
    
    Game_System.prototype.inRoom = function() {
        return $gameSwitches.value(14);
    };
    
    Game_System.prototype.bornEncount = function(num) {
        for (var i = 0; i < (num || 1); i++) {
            var xy = $gameSystem.getFreeXyNearPlayer();
            if (xy) {
                var regionId = $gameSystem.getMostNearRegionId(xy[0], xy[1]);
                if ($gameMap.numRegionEnemies(regionId) < 9) {
                    var id = $gameSystem.encountEnemyId(regionId);
                    if (id) {
                        $gameSystem.bornEnemy(id, xy[0], xy[1], regionId);
                        $gameMap.rejudgeEvents();
                    }
                }
            }
        }
    };
    
    Game_System.prototype.getHeal = function() {
        NWS()._heal++;
        NWS()._heal = NWS()._heal.clamp(0, NWS()._healsMax)
    };
    
    Game_System.prototype.isSaveOk = function() {
//        return $dataMap.meta.saveOk || (!$dataMap.meta.Dungeon && !$gameSwitches.value(18));
//        return !$gameSwitches.value(18) && (!$dataMap.meta.maojo || $dataMap.meta.saveOk);
        return !$gameSwitches.value(18) && $dataMap.meta && !$dataMap.meta.noSave &&
            !this.isFlying() && !$gameSwitches.value(50);
    };
    
    //武器庫を開けるか
    Game_System.prototype.isStocksOk = function() {
        return !$dataMap.meta.Dungeon && !$gameSwitches.value(18) && !$dataMap.meta.SBI;
    };
    
    //手持ちまたは武器庫に一つでも持っている
    Game_System.prototype.hasWeapon = function(weaponId) {
        return NWS()._weapons.some(function(weapon) {
            return !!weapon && weapon._itemId === weaponId;
        }) || NWS()._stocks.some(function(weapon) {
            return !!weapon && weapon._itemId === weaponId;
        })
    }
    //入手済みだが持ってないし鍛冶屋に在庫もない状態
    Game_System.prototype.cannotFindWeapon = function(weaponId, withoutHasGot) {
        return (withoutHasGot || $gameSystem.hasGot(weaponId)) &&
            !$gameSystem.hasWeapon(weaponId) && !NWS()._makeItems[weaponId] &&
            !NWS()._shopItems.some(function(si) {
                return si.some(function(item) {
                    return item && item._itemId === weaponId;
                })
            });
    };
    
    //生き物をすべて拾ったかどうかの判定
    Game_System.prototype.gotEveryAlive = function() {
        return $dataItems.every(function(item) {
            return (!item || !item.meta.alive) ||
                ($gameSystem.hasWeapon(item.id) || NWS()._shopItems.some(function(si) {
                return si.some(function(it) {
                    return it && it._itemId === item.id;
                })
            }))
        });
    };
    
    //世界滅亡時はbgm自動再生無効
    var _Game_Map_autoplay = Game_Map.prototype.autoplay;
    Game_Map.prototype.autoplay = function() {
        //ついでにこのとき世界滅亡判定を更新
        if ($gameVariables.value(38) > 0 && !$gameSystem.gotEveryAlive())
            $gameVariables.setValue(38, 0);
        
        if ($gameVariables.value(38) <= 0) {
            _Game_Map_autoplay.apply(this, arguments);
        } else {
            if ($dataMap.meta && $dataMap.meta.ifNoAliveNotBgm) AudioManager.stopBgm();
            else _Game_Map_autoplay.apply(this, arguments);
        }
    };
    
    //-----------------------------------------------------------------------------
    // Game_CharacterBase
    //-----------------------------------------------------------------------------
    
    //初期化
    var _Game_CharacterBase_initMembers = Game_CharacterBase.prototype.initMembers;
    Game_CharacterBase.prototype.initMembers = function() {
        _Game_CharacterBase_initMembers.apply(this, arguments);
        this._D         = null;
        this._DId       = 0;    //敵やアクターなどのID
        this._DType     = 0;    //1:敵 2:アクター 3:ギミック 4:アイテム 5:防具 6:金
        this._DCount    = 0;    //行動
        
        this._param = this._param || {};
        this._motion = '';
        this._maxAction = 1;
        this._maxAttack = 1;
        this._DActionCount = 0;
        this._DAttackCount = 0;
        this._targets = [];
    };
    
    //Dオブジェクトをセット
    Game_CharacterBase.prototype.setD = function() {
        if (!this._D) {
            switch (this._DType) {
                case 1 :
                    this._D = new Game_Enemy(this._DId, 0, 0);
                    break;
                case 2 :
                    this._D = new Game_Actor(this._DId);
                    break;
                case 3 :
                    this._D = new Game_Enemy(this._DId, 0, 0);
                    break;
                case 4 :
                    this._D = $gameSystem.newItem(this._DId);
                    break;
                case 5 :
                    this._D = $gameSystem.newArmor(this._DId);
                    break;
                case 6 :
                    this._D = $gameSystem.newGold(this._gold);
                    break;
            }
        }
        if (!this._D) return this._DType = 0;
        this._D._event = this;
        if (this.isCharacter()) {
        } else if (this.isItem()) {
            this.setWalkAnime(false);
            this.setStepAnime(false);
            this.setDirectionFix(true);
            if (!this._D._gold && this._D.object().meta.characterImage) {
                var imageInfo = this._D.object().meta.characterImage.split(',');
                this._characterName = imageInfo[0], this._characterIndex = Number(imageInfo[1]);
                this._customResource = null, this._graphicColumns = this._graphicRows = 1;
                this._stepAnime = true;
                this._directionFix = false;
            } else {
                //武器投げ用　武器画像設定
                this._customResource = 'Weapon';
                this._graphicColumns = this._graphicRows = 1;
                this._characterName = this._D.imageName();
                this._characterIndex = 0;
                this._additionalY = -24;
                this._originX = this._originY = 0.5;
                this._rotateSprite = true;
            }
        }
    };
    
    //Dオブジェクト処理を適用するかどうか
    Game_CharacterBase.prototype.isD = function() {
        return this._DType && (!this._eventId || this._pageIndex >= 0);
    };
    //人オブジェクトかどうか 敵、アクター、ギミック
    Game_CharacterBase.prototype.isCharacter = function() {
        return this.isD() && this._DType <= 3;
    };
    //物オブジェクトかどうか アイテム、防具、金
    Game_CharacterBase.prototype.isItem = function() {
        return this.isD() && this._DType > 3;
    };
    
    //アイテム名(アイコン+アイテム)の取得
    Game_CharacterBase.prototype.itemName = function(withIcon, withNum) {
        if (!this.isItem()) return '';
        return this._D.itemName(withIcon, withNum);
    };
    
    Game_CharacterBase.prototype.isPlayer = function() {
        return false;
    };
    
    Game_CharacterBase.prototype.frontX = function() {
        return $gameMap.roundXWithDirection(this.x, this._direction);
    };
    Game_CharacterBase.prototype.frontY = function() {
        return $gameMap.roundYWithDirection(this.y, this._direction);
    };
    
    //通行可能判定更新 キャラにかぶらない
    var _Game_CharacterBase_canPass = Game_CharacterBase.prototype.canPass;
    Game_CharacterBase.prototype.canPass = function(x, y, d) {
        var x2 = $gameMap.roundXWithDirection(x, d);
        var y2 = $gameMap.roundYWithDirection(y, d);
        var rId = $gameMap.regionId(x, y), rId2 = $gameMap.regionId(x2, y2);
        if (!$gameMap.isValid(x2, y2)) return false;
        if (x2 < 8 || x2 >= $dataMap.width - 8 || y2 < 4 || y2 >= $dataMap.height - 4) return false; //画面端行けない
        if (this.isThrough() || this.isDebugThrough()) return true; //すり抜け・デバッグ
        if (this.isPlayer() && $gameSystem.isFlying()) return true; //空飛んでる
        if (this._throwDirection) return true;
//        if ([$gamePlayer].concat($gameMap.eventsXy(x2, y2)).some(function(event) { //Dキャラがいる
//            return event !== this && event.pos(x2, y2) && event.isCharacter() &&
//                !(this.isPlayer() && event._canTradePos && event._D.canMove());
//        }, this)) return false;
        if (this.roomStateDiffer({x : x2, y : y2}))
            return false; //室内から外への通行禁止
        //リージョン判定
        if (!this.isPlayer() && $gameMap.regionId(x2, y2) === 82 &&
            $gameVariables.value(9) > 0) return false; //チュートリアル敵通行不可
        if (this._NPC && !this._movePattern && !this._attackMode &&
            $gameMap.regionId(x, y) !== $gameMap.regionId(x2, y2)) return false; //NPCのルート設定用
        
//        if ($gameMap.regionId(x2, y2) === 3) return true; //リージョン3はイベントがあっても通行可能
        if (this.isPlayer() && $gameMap.eventsXy(x2, y2).some(function(event) {
            return event.event() && !event._erased && event.event().meta.canPass;
        }, this)) return true; //<canPass>イベントがいれば通行可能
        if (this.isCollidedWithCharacters(x2, y2)) return false; //通常キャラがいる
//        if (this.isCharacter() && this._D.metaState('through')) return true; //ステート_through (空間移動)
        if (this._move === 1) return true; //空間移動
        if (!$gameSystem.isGround(x2, y2)) return false;
        if (!this.isMapPassable(x, y, d)) return false;
        return true;
    };
    
    Game_Event.prototype.isCollidedWithEvents = function(x, y) {
        return Game_CharacterBase.prototype.isCollidedWithEvents.apply(this, arguments);
    };
    
    //行動回数の決定
    Game_CharacterBase.prototype.setDCount = function() {
        if (this._D.clearActions) this._D.clearActions();
        this._DCount = Math.max(this._DCount + 1, 1);
    };
    
    //移動で行動消費
    var _Game_CharacterBase_moveStraight = Game_CharacterBase.prototype.moveStraight;
    Game_CharacterBase.prototype.moveStraight = function(d) {
        _Game_CharacterBase_moveStraight.apply(this, arguments);
        if (this.isMovementSucceeded() && this.isCharacter() && !$gameMap.isEventRunning()) {
            this._DCount--;
            this._canGetItem = true;
        }
    };
    
    //移動にかかる時間を取得
    Game_CharacterBase.prototype.moveTime = function() {
        return 1 / this.distancePerFrame();
    };
    
    //1ターンあたり行動回数
    Game_CharacterBase.prototype.turnActionNum = function() {
        var max = this._attackMode && this._destination ? this._maxAction : 1;
        return this.isCharacter() ? max + this._D._buffs[6] : 0;
    };
    //1ターンあたり攻撃回数
    Game_CharacterBase.prototype.turnAttackNum = function() {
        return this.isCharacter() ? this._maxAttack + this._D._buffs[6] : 0;
    };
    
    //周囲のアイテムのない地面を探す 階段もダメ
    Game_CharacterBase.prototype.findNoItemXy = function(centerX, centerY) {
        for (var i = 0; i < 9; i++) {
            var x = centerX + [0, 0, -1, 0, 1, -1, -1, 1, 1][i], y = centerY + [0, 1, 0, -1, 0, 1, -1, -1, 1][i];
            if ($gameSystem.isGround(x, y) && !$gameMap.eventsXy(x, y).some(function(event) {
                return event.isItem() || event._marker === 7;
            })) return [x, y];
        }
        return null;
    };
    
    //キャラとの距離をだす
    Game_CharacterBase.prototype.distanceFrom = function(character) {
        var x = character.x, y = character.y;
        return Math.sqrt(Math.pow(this.deltaXFrom(x), 2) + Math.pow(this.deltaYFrom(y), 2));
    };
    //キャラとの正確な距離をだす
    Game_CharacterBase.prototype.realDistanceFrom = function(character) {
        var x = character._realX, y = character._realY;
        return Math.sqrt(Math.pow($gameMap.deltaX(this._realX, x), 2) + Math.pow($gameMap.deltaY(this._realY, y), 2));
    };
    
    //キャラクターのいる方向を取得する
    Game_Character.prototype.getTowardCharacter = function(character) {
        var sx = this.deltaXFrom(character.x), sy = this.deltaYFrom(character.y);
        if (Math.abs(sx) > Math.abs(sy)) return sx > 0 ? 4 : 6;
        else if (sy !== 0) return sy > 0 ? 8 : 2;
        return this._direction;
    };
    
    //家の外と中のため互いに干渉しない状態かどうか
    Game_Character.prototype.roomStateDiffer = function(character) {
        return $gameMap.roomStateDiffer(this.x, this.y, character.x, character.y);
    };
    
    //スキルがターゲットに届くかどうか
    Game_CharacterBase.prototype.inRange = function(skill, target, x, y, d) {
        if (target._D.metaState('transparent')) return false; //ステート_transparent
        if (x === undefined) x = this.x;
        if (y === undefined) y = this.y;
        d = d || this.getTowardCharacter(target);
        return $gameSystem.getSkillRange(skill, x, y, d).some(function(xy) {
            return target.pos(xy[0], xy[1]);
        })
    };
    
    //ターゲットにスキル/アイテムを適用する
    Game_CharacterBase.prototype.applyAction = function(target, noEffect, isFirst) {
        if (!this._action || !target.isCharacter()) return;
        if (target._D.metaState('muteki')) { //ステート効果_muteki
            $gameSystem.setDisplaySe('miss');
//            $gameSystem.display('%1には何も効かない！'.format(target._D.name()));
        } else {
            this._action._noEffect = !!noEffect;
            this._action._isFirst = !!isFirst;
            this._action.apply(target._D);
            $gameSystem.popResult(target, false, this);
        }
    };
    //ダメージのみ
    var _Game_Action_applyItemEffect = Game_Action.prototype.applyItemEffect;
    Game_Action.prototype.applyItemEffect = function(target, effect) {
        if (!this._noEffect) _Game_Action_applyItemEffect.apply(this, arguments);
    };
    
    //コモンイベントによるアクション再生を開始
    Game_CharacterBase.prototype.startAction = function(action, targets) {
        if (this._D.isDead()) {
            this._DCount = 0;
            return;
        }
        this._action = action;
        this._action.setSubject(this._D);
        if (this._eventId && this._D.metaState('confuse') && Math.randomInt(3))
            this.setDirection([2, 4, 6, 8][Math.randomInt(4)]); //ステート_confuse
        else if (this._target) this.turnTowardCharacter(this._target);
        if (targets) {
            this._targets = targets;
            var xyList = targets.map(function(t) {return [t.x, t.y]});
        } else {
            var list = [];
            var rangeItem = action._byThrowingWeapon ? {meta : {rangeType : 28, through : false}} : this._action.item();
            var xyList = $gameSystem.getSkillRange(rangeItem, this._x, this._y, this._direction);
            if (action._isThrowingChild) xyList = [[action._throwingChildTarget.x, action._throwingChildTarget.y]];
            this._action._xyList = xyList;
            xyList.forEach(function(xy) {
                var a = $gameMap.eventsXy(xy[0], xy[1]).filter(function(event) {
                    return event.isCharacter() && !event._D.isDead();
                });
                list = list.concat(a);
                if ($gamePlayer.pos(xy[0], xy[1])) list.push($gamePlayer);
            })
            this._targets = list;
        }
        var ch = this;
        this._targets.sort(function(a, b){
            if (!a) return 0;
            var aF = a.pos(ch.frontX(), ch.frontY()), bF = b.pos(ch.frontX(), ch.frontY());
            if (aF !== bF) return aF ? -1 : 1;
            var A = a.distanceFrom(ch), B = b.distanceFrom(ch);
            return (A < B) ? -1 : (A > B) ? 1 : 0;
        }); 
        
        $gameSystem._actionInfo = {
            action  : this._action,
            subject : this,
            target  : this._target,
            targets : this._targets,
            xys     : xyList
        }
        $gameSwitches.setValue(2, true);
        this._DCount--;
    };
    
    //スキルを使用
    Game_CharacterBase.prototype.useSkill = function(skillId, use, footId, onlyEffect, user) {
        var action = new Game_Action(this._D);
        action.setSkill(skillId);
        this._D.setAction(0, action);
        SceneManager._scene.reserveAction(this, action, use, footId, onlyEffect);
        return action;
    };
    //アイテムを自分に使用 (使用回数の減少は別途で行う)
    Game_CharacterBase.prototype.useItem = function(item, use, footId, onlyEffect, byPlayerWeapon, byThrowingWeapon) {
        this._target = this;
        var action = new Game_Action(this._D);
        action._item = item;
        if (byPlayerWeapon) action._byPlayerWeapon = true;
        if (byThrowingWeapon) action._byThrowingWeapon = true;
        this._D.setAction(0, action);
        SceneManager._scene.reserveAction(this, action, use, footId, onlyEffect);
    };
    
    //アイテムを投げる
    Game_CharacterBase.prototype.throwItem = function(item, noMessage, through, speed) {
        $gameSystem.putItem(item, this.x, this.y, this._direction, through, speed);
        var name = item.itemName(true, true);
        $gameSystem.setDisplaySe('throw');
        if (!noMessage) $gameSystem.display(_lgCheck('%1は%2を投げた！').format(this._D.name(), name), 0, 0, 0, 0, 1);
        this._DCount--;
    };
    
    //モーション
    Game_CharacterBase.prototype.setMotion = function(motion) {
        this._motion = motion || '';
        this._motionCount = 0;
        this._additionalX = 0;
        this._lastParam = 0;
        this._updateFrequently = !!this._motion;
    };
    Game_CharacterBase.prototype.updateMotion = function() {
        if (!this._motion) return;
        var c = this._motionCount;
        if (this._motion === 'damage') {
            if (c === 0) {
                this._lastParam = this._additionalX;
            } else if (c < 18) {
                this._additionalX = this._lastParam + (c % 4 < 2 ? 2 : -2);
            } else {
                if (this._turnTowardAfterDamage) {//ダメージ後ターゲットのほうを見る
                    if (this._target && this._D.canMove() && !this._D._dead) this.turnTowardCharacter(this._target);
                    this._turnTowardAfterDamage = false;
                }
                this._additionalX = this._lastParam, this.setMotion();
            }
        } else if (this._motion === 'dead') {
//            if (c === 0) {
//                this._additionalX = this._lastParam;
//                this._needDeleteHpGauge = true;
//                var jx = $gamePlayer.x + (this.x > $gamePlayer.x ? 9 : this.x < $gamePlayer.x ? -9 :
//                                          [9, -9][Math.randomInt(2)]) - this.x;
//                var jy = (this.y > $gamePlayer.y ? 4 : this.y < $gamePlayer.y ? -4 : 0) + rand(-2, 2);
//                this.__rotationPlus = rand(24, 48) * [1, -1][Math.randomInt(2)];
//                this._bJumpX = this.x, this._bJumpY = this.y;
//                this.setMoveSpeed(0.1), this.jump(jx, jy);
//                this.requestAnimation(2);
//            }
//            if (c > 0) {
//                if (this.isJumping()) this._angle += this.__rotationPlus;
//                else this.setMotion(), this.dead();
//            }
            if (c === 0) {
                if (!this.isPlayer()) {
                    this._transparent = true;
                    $gameSystem.addEnemyDeadEffect(this, [$gamePlayer.x, $gamePlayer.y, this.x, this.y],
                                        $gamePlayer.attackItem().power() * $gamePlayer.attackItem().object().repeats);
                }
                this.setMotion(), this.dead();
            }
        } else if (this._motion === 'levelUp') {
            $gameSwitches.setValue(4, true); //レベルアップコモンイベント実行
            this.setMotion();
        } else {
            this.setMotion(); //モーションをクリア
        }
        this._motionCount++; 
    };
    
    //死ぬ処理
    Game_CharacterBase.prototype.dead = function() {
        if (this._D.metaState('kago') || this.metaItem('kago')) {
            if (this._D.metaState('kago')) { //ステート「加護」
                var item = null;
                var sId = 23;
            } else { //ライフの石を使う場合
                var item = this.metaItem('kago');
                var sId = 12;
            }
            this.useSkill(sId, item);
            this.setMotion();
            this._D._dead = false;
            return false;
        } else {
            return true;
        }
    };
    
    Game_CharacterBase.prototype.isInsideRange = function(sx, sy, a) {
        var w = this._KNHBlockWidth || 1, h = this._KNHBlockHeight || 2;
        var x = this.x - (Math.ceil(w / 2) - 0.5), y = this.y - h;
        var cx = $gameMap.displayX() + 7.5, cy = $gameMap.displayY() + 3.5;
        return (x + w >= cx - sx - a) && (x < cx + sx + a) &&
            (y + h >= cy - sy - a) && (y <= cy + sy + a);
    };
    //近くにいるか
    Game_CharacterBase.prototype.isNearPlayer = function() {
        return this.isInsideRange(1, 1, 0);
    };
    //画面外にいるか
    Game_CharacterBase.prototype.isOutOfScreen = function() {
        return !this.isInsideRange(9, 5, 2);
    };
    
    //現在の部屋
    Game_CharacterBase.prototype.room = function() {
        if (!$gameMap.mapGenerator()) {
            return $gameMap.regionId(this.x, this.y) || null;
        }
        return $gameMap.mapGenerator().roomByXY(this.x, this.y) || null;
    };
    
    //足踏みアニメの速さ変更
    Game_CharacterBase.prototype.animationWait = function() {
        return (9 - this.realMoveSpeed()) * 4;
    };
    var _Game_CharacterBase_updateAnimationCount = Game_CharacterBase.prototype.updateAnimationCount;
    Game_CharacterBase.prototype.updateAnimationCount = function() {
        _Game_CharacterBase_updateAnimationCount.apply(this, arguments);
        if (this.isMoving() && this.hasWalkAnime()) this._animationCount += 1;
        if (this._stepAnimeSpeed && this._stepAnimeSpeed > 1) this._animationCount += this._stepAnimeSpeed - 1;
    };
    var _Game_CharacterBase_updateAnimation = Game_CharacterBase.prototype.updateAnimation;
    Game_CharacterBase.prototype.updateAnimation = function() {
        if (!this.hasStepAnime() && !this.hasWalkAnime()) return;
        _Game_CharacterBase_updateAnimation.apply(this, arguments);
    };
    
    //更新
    var _Game_CharacterBase_update = Game_CharacterBase.prototype.update;
    Game_CharacterBase.prototype.update = function() {
        if ($gameSystem.inMenu()) return;
        _Game_CharacterBase_update.apply(this, arguments);
        if (this.isCharacter()) {
            if (this.isStopping()) this._canGetItem = false;
            this.updateMotion();
            //行動不能時足踏みOFF
            this._stepAnime = this._D && this._D.restriction() < 4;
        }
    };
    
    //軽量化用
    Game_CharacterBase.prototype.needNotUpdate = function() {
        if (!$dataMap || !this._eventId || !this.event()) return false;
        return !this._important &&
               !(this.isCharacter() && $dataMap.meta.SBI) &&
               ((this._transparent && !this.isNearPlayer()) ||
                this.isOutOfScreen() ||
                this._pageIndex < 0);
    };
    
    Game_CharacterBase.prototype.needNotSprite = function() {
        if (!$dataMap || !this._eventId || !this.event()) return true;
        return this.needNotUpdate() ||
            (!this._important &&
             $gameSystem.inRoom() && !(this.event().meta.canByHouse) && this.regionId() !== 16);
    };
    
    Game_CharacterBase.prototype.needNot = function() {
        if (!$dataMap || !this._eventId || !this.event()) return false;
        return this.needNotUpdate() && !this.isInsideRange(25, 15, 2);
    };
    
    //-----------------------------------------------------------------------------
    // Game_Player
    //-----------------------------------------------------------------------------
    
    //プレイヤー初期化
    var _Game_Player_initialize = Game_Player.prototype.initialize;
    Game_Player.prototype.initialize = function() {
        _Game_Player_initialize.apply(this, arguments);
        this._DId = 1;
        this._DType = 2;
        this._lastMp = 0;
        this._sp = 0;
        this._gotDetails = [];
        this._hitAttack = false;
        this.setD();
    };
    
    //プレイヤーのDセット
    Game_Player.prototype.setD = function() {
        this._D = $gameActors.actor(1);
        this._D._event = this;
        this.setStepAnime(true);
    };
    
    //行動回数の決定
    Game_Player.prototype.setDCount = function() {
        if (this._D.clearActions) this._D.clearActions();
        this._DCount = Math.max(this._DCount + this._maxAction + this._D._buffs[6], 1);
    };
    
    Game_Player.prototype.isPlayer = function() {
        return true;
    };
    
    //Dダンジョン内での入力操作を変更
    var _Game_Player_moveByInput = Game_Player.prototype.moveByInput;
    Game_Player.prototype.moveByInput = function() {
        if (!this._fixMoveSpeed)
            this._moveSpeed = 
                $gameSystem.isFlying() ? 5 :
                (this._dashDirection || this.isFootStepping()) ? 7 :
                $gameTemp.isDestinationValid() ? 4.5 : 4.5; //速度設定
        if (this.isFootStepping()) { //足踏み
            this._DCount--;
            return;
        }
        if (this.isSkillCalling() && !SceneManager._scene._attackButton._frameType) { //奥義発動
            $gameSwitches.setValue(5, true);
            return;
        }
        if (this.isUsefulCalling() && !$gameSystem.inMenu()) {//便利コマンド
            if (Input.isTriggered('ok')) {
                var list = NWS()._weapons.filter(function(w) {return !!w});
                var uwp = list[Math.randomInt(list.length)];
                if (uwp) {
                    this.equipWeapon(uwp);
                    return;
                }
            } else if (Input.isTriggered('cancel')) {
                this.removeWeapon();
                return;
            }
        }
        if (!SceneManager._scene._free) {
            $gameTemp.clearDestination();
        } else {
        }
        
        var canMove = this.canInput();
        //直前のシーンの入力を判定に含まない
        if (TouchInput.isPressed() && ($gameSystem.inMenu() || $gameSystem.isBusy() ||
            SceneManager._scene.isTouchedInsideButton()))
            this._cannotAllow = true;
        else if (this._cannotAllow && !TouchInput.isPressed()) this._cannotAllow = false;
        if ($gameSystem.isBusy() || $gameSystem.inMenu() || 
            !canMove || this._cannotAllow) {
            NWS()._isShift = false;
            return;
        }
        
        var acted = false;
        if ($gameSystem.isFlying()) {
            NWS()._isShift = false;
        } else if (Input.isPressed('shift')) { //shiftキー
            if (!NWS()._isShift) AudioManager.playSe({name:'Equip1', volume:70, pitch:150, pan:0});
            NWS()._isShift = true;
            $gameTemp.clearDestination();
            var direction = this.getInputDirection();
            if (direction > 0) {
                this.DSetDirection(direction);
                acted = true;
            }
        } else {
            if (TouchInput.isPressed()) {
                if ($gameSystem.touchRect(360, 168, 48, 48)) { //shiftタッチ
                    if (!NWS()._isShift) AudioManager.playSe({name:'Equip1', volume:70, pitch:150, pan:0});
                    NWS()._isShift = true;
                    $gameTemp.clearDestination();
                } else if (NWS()._isShift) { //スライド方向転換判定
                    var dx = TouchInput.x - 360, dy = TouchInput.y - 216;
                    var direction = 0;
                    if (Math.abs(dx) > Math.abs(dy)) direction = dx < 0 ? 4 : 6;
                    else direction = dy < 0 ? 8 : 2;
                    if (this._D.metaState('confuse')) direction = 10 - direction; //ステート_confuse
                    if (direction) this.setDirection(direction);
                }
            } else {
                NWS()._isShift = false;
            }
        }
        
        if (!acted) { //通常移動
            if ($gameVariables.value(9) === 5) return; //チュートリアル
            var direction = this.getInputDirection();
            if (direction > 0) { //キーによる移動
//                this._tDir = direction;
                if (this._D.metaState('confuse')) direction = 10 - direction; //ステート_confuse
                this.setThrough(false);
                this.executeMove(direction);
                $gameTemp.clearDestination();
                acted = true;
            } else if ($gameTemp.isDestinationValid()) { //タッチによる移動
                var direction;
                if (this._D.metaState('confuse')) {
                    if (TouchInput.isPressed()) {
                        var dx = TouchInput.x - 360, dy = TouchInput.y - 216;
                        if (Math.abs(dx) > Math.abs(dy)) direction = dx < 0 ? 4 : 6;
                        else direction = dy < 0 ? 8 : 2;
                        direction = 10 - direction;
                    }
                } else {
                    if (false && !$gameTemp._wasAutoStopping && this.autoStop(1)) {
                        $gameTemp.clearDestination();
                    } else {
                        var x = $gameTemp.destinationX();
                        var y = $gameTemp.destinationY();
                        direction = this.findDirectionTo(x, y);
                    }
                }
                if (direction) {
                    this.setThrough(false);
                    this.moveStraight(direction);
                }
            }
        }
    };
    
    //方向転換攻撃
    Game_Player.prototype.DSetDirection = function(direction) {
        if (this._D.metaState('confuse')) direction = 10 - direction; //ステート_confuse
        var lastD = this._direction;
        this.setDirection(direction);
    };
    //攻撃実行
    Game_Player.prototype.startAttack = function() {
        var item = this.attackItem();
        this._usingChildSkill = false;
        this.useItem(item, null, null, null, !!NWS()._equip);
    };
    //攻撃スキルID
    Game_Player.prototype.attackItem = function() {
        return NWS()._equip || $gameSystem.newItem(1);
    };
    
    //足踏み判定
    Game_Player.prototype.isFootStepping = function() {
        var button = SceneManager._scene._skipButton;
        if (!button) return;
        if (button._touching) button._count = (button._count || 0) + 1;
        else button._count = 0;
        return button._touching && button._count > 30;
    };
    
    //必殺奥義入力判定
    Game_Player.prototype.isSkillCalling = function() {
        var button = SceneManager._scene._attackButton;
        if (!button || !button.active) return;
        if (button._touching) button._count = (button._count || 0) + 1;
        else button._count = 0;
        return button._touching && button._count > 30 &&
            SceneManager._scene._free && !$gameSwitches.value(5);
    };
    
    //便利コマンド用Fキー入力判定
    Game_Player.prototype.isUsefulCalling = function() {
        var button = SceneManager._scene._changeWeaponButton;
        var mw = SceneManager._scene._menuWindow, ww = SceneManager._scene._weaponListWindow;
//        if (Input.isPressed('F')) button._touching = true;
        return (mw._menuMode === 'weaponList' && ww._type === 0 &&
                Input.isPressed('F')) ||
            (button._touching && SceneManager._scene._free);
    };
    
    //アイテム入手
    Game_Player.prototype.getItem = function(item) {
        item._gold ? $gameParty.gainGold(item._gold) : NWS()._items.push(item);
    };
    //アイテム消去
    Game_Player.prototype.eraseItem = function(item) {
        var index = NWS()._items.indexOf(item);
        if (index >= 0) {
            NWS()._items.splice(index, 1);
        } else { //入れ物の中も参照
            NWS()._items.some(function(item2) {
                var index2 = item2._inside.indexOf(item);
                if (index2 >= 0) {
                    item2._inside.splice(index2, 1);
                    return true;
                }
            })
        }
    };
    
    //武器入手
    Game_Player.prototype.getItem = function(item, equip, noMessage) {
        NWS()._getId = NWS()._getId || 0;
        item._getId = ++NWS()._getId; //使用順ソート用
//        if ($dataMap.meta.maojo) {
//            NWS()._stocks.push(item);
//            if (!noMessage) {
//                $gameSystem.setDisplaySe('chest');
//                var text =[
//                    '%2を武器庫に送った。', 'The %2 will be sent to your Armory.',
//                    '%2(을)를 무기고로 보냈다.', '%2已送到武器庫了。', '%2已送到武器库了。'][_lg()];
//                $gameSystem.display(text.format(this._D.name(), item.itemName(true, true)));
//            }
//            return;
//        }
        if ($gameSystem.weaponsMax()) {
            NWS()._stocks.push(item);
            if (!noMessage) {
                $gameSystem.setDisplaySe('chest');
                var text =[
                    'これ以上武器を持てない！%2を武器庫に送った。',
                    'The %2 will be sent to your Armory.',
                    '%2(을)를 무기고로 보냈다.',
                    '無法再攜帶更多武器！%2已送到武器庫了。',
                    '无法再携带更多武器！%2已送到武器库了。'][_lg()];
                $gameSystem.display(text.format(
                    this._D.name(), item.itemName(true, true)));
            }
        } else {
            for (var i = 0; i < NWS()._weaponsMax; i++)
                if (!NWS()._weapons[i]) {
                    NWS()._weapons[i] = item;
                    break;
                }
            if (equip) {
                this.equipWeapon(item, noMessage);
            } else if (!noMessage) {
                $gameSystem.setDisplaySe('bow');
                var text = [
                    '%1は%2をしまった！', '%1 put away the %2!	', '%1는 %2(을)를 집어넣었다!',
                    '%1收起%2了！', '%1收起了%2！'][_lg(0)];
                $gameSystem.display(text.format(this._D.name(), item.itemName(true, true)));
            }
        }
    };
    //武器削除
    Game_Player.prototype.removeItem = function(item) {
        if (item === NWS()._equip) this.removeWeapon(true);
        NWS()._weapons[NWS()._weapons.indexOf(item)] = null;
    };
    
    //武器セット
    Game_Player.prototype.equipWeapon = function(item, noMessage) {
        if (!item) return;
        NWS()._equip = item;
        NWS()._lastUsedId = NWS()._lastUsedId || 0;
        item._lastUsedId = ++NWS()._lastUsedId; //使用順ソート用
        if (!noMessage) {
            $gameSystem.setDisplaySe('equip');
            var text = ['%1は%2を装備した！', '%1 equipped the %2!',
                        '%1는 %2(을)를 장비했다!', '%1裝備%2了！', '%1装备了%2！'][_lg()];
            $gameSystem.display(text.format(this._D.name(), item.itemName(true, true)));
        }
        NWS()._loseUseable = false;
        this._weaponFire = false;
        this._D.refresh();
    };
    Game_Player.prototype.removeWeapon = function(noMessage) {
        if (!NWS()._equip) return;
        if (!noMessage) {
            $gameSystem.setDisplaySe('equip');
            var text = ['%1は%2を外した！', '%1 removed the %2!',
                        '%1는 %2(을)를 해제했다!', '%1卸下%2了！', '%1卸下了%2！'][_lg()];
            $gameSystem.display(text.format(this._D.name(), NWS()._equip.itemName(true, true)));
        }
        NWS()._equip = null;
        this._weaponFire = false;
        this._D.refresh();
    };
    //武器耐久値減少
    Game_Player.prototype.loseUseable = function(type) {
        NWS()._loseUseable = false;
        
        var weapon = NWS()._equip, tgRemoved;
        if (!weapon) return;
        if ((type && weapon._mekki) || (weapon._mekki && weapon._mekki - 1 <= 0)) {
            weapon._mekki = 0;
            $gameSystem.setDisplaySe('down');
            var text = ['%1のメッキがとれてしまった！', 'The galvanization on the %1 wore off!',
                        '%1의 도금이 벗겨지고 말았다!', '%1的鍍金剝落了！', '%1的镀金剥落了！'][_lg()];
            $gameSystem.display(text.format(weapon.itemName(1)));
            return;
        } else if (weapon._mekki) {
            weapon._mekki--;
        } else {
            weapon._useable--;
            if (weapon._useable <= 0 && weapon._lastUseable > 0) {
                $gameSystem.setDisplaySe('warning');
                $gameSystem.setDisplaySe('crash');
                var text = ['%1は壊れてしまった・・・。', 'The %1 broke...	',
                            '%1(은)는 부서지고 말았다・・・', '%1壞掉了……', '%1坏掉了……'][_lg()];
                $gameSystem.display(text.format(weapon.itemName(1)));
                this.weaponBreakEffect(30);
                $gameSystem.revivalGotEvent(weapon);
                this.removeItem(weapon);
                if (this._D.metaState('cannotChangeWeapon'))
                    this._D.removeState(this._D.metaState('cannotChangeWeapon'));
                return;
            } else {
                $gameSystem.setDisplaySe('piki');
                var text = ['%1の耐久値が 1 減った！', 'The %1 lost 1 durability point!',
                            '%1의 내구도가 1 감소했다!', '%1的耐久值減少1點了！', '%1的耐久值减少了1点！'][_lg()];
                $gameSystem.display(text.format(weapon.itemName(1)));
                this.weaponBreakEffect(3);
            }
            weapon._lastUseable = weapon._useable;
        }
        if (type) return;
        if (weapon._togi) {
            weapon._togi--;
            if (!weapon._togi) {
                $gameSystem.setDisplaySe('down');
                var text = ['%1の斬れ味が普通に戻った！', 'The sharpness of the %1 returned to normal!',
                            '%1의 예리도가 보통 상태로 돌아갔다!', '%1的鋒利程度恢復至普通了！', '%1的锋利程度恢复至普通了！'][_lg()];
                $gameSystem.display(text.format(weapon.itemName(1)));
            }
        }
    };
    Game_Player.prototype.weaponBreakEffect = function(num) {
        var chSprite = 
            SceneManager._scene._spriteset._characterSprites.filter(function(sprite, index) {
                return sprite._character instanceof Game_Player;
            }, this)[0];
        var wpSprite = chSprite._weaponSprite;
        if (!wpSprite) return;
        wpSprite.startBreakEffect(num);
    };
    
    //特定のmetaアイテムを持っているか
    Game_Player.prototype.metaItem = function(metaName) {
        var _item = null;
        NWS()._items.some(function(item) {
            if (!item._gold && item.object().meta[metaName]) _item = item;
        })
        return _item;
    };
    
    //死ぬ処理
    Game_Player.prototype.dead = function() {
        if (!Game_CharacterBase.prototype.dead.apply(this, arguments)) {
            return false;
        } else {
            $gameSystem.playDisplaySe('kote');
            this._characterIndex = 4;
            NWS()._cannotAction = true;
            $gameSwitches.setValue(7, true);
        }
    };
    
    var _Game_Player_update = Game_Player.prototype.update;
    Game_Player.prototype.update = function() {
        _Game_Player_update.apply(this, arguments);
        if (!$gameSwitches.value(11)) this.center(this._realX, this._realY);
        this._equip = NWS()._equip;
    };
    
    //経験値とお金獲得
    Game_Player.prototype.gainExpAndGold = function() {
        if (NWS()._turnExp) {
//            $gameSystem.setDisplaySe('exp');
            var text = ['%1は %2 の経験値を手に入れた！', '%1 earned %2 EXP!',
                        '%1는 경험치 %2(을)를 획득했다!', '%1獲得經驗值 %2 了！', '%1获得%2经验值！'][_lg()];
            $gameSystem.display(text.format($gamePlayer._D.name(), NWS()._turnExp), 0, 0, 0, 0, 60);
            $gameSystem.displayExp(NWS()._turnExp);
            NWS()._turnExp = 0;
        }
        if (NWS()._turnGold) {
            $gameSystem.setDisplaySe('gold');
            var text = ['%1\\g のお金を手に入れた！', 'You got %1\\g!',
                        '%1\\g의 돈을 획득했다!', '獲得金錢 %1\\g 了！', '获得%1\\g金钱！'][_lg()];
            $gameSystem.display(text.format(NWS()._turnGold));
            $gameParty.gainGold(NWS()._turnGold);
            NWS()._turnGold = 0;
        }
    };
        
    //決定で起動イベの起動条件を追加
    var _Game_Player_canStartLocalEvents = Game_Player.prototype.canStartLocalEvents;
    Game_Player.prototype.canStartLocalEvents = function() {
        return (this.canInput()) &&
            _Game_Player_canStartLocalEvents.apply(this, arguments);
    };
    //接触起動イベの起動タイミングを変更 その他
    var _Game_Player_updateNonmoving = Game_Player.prototype.updateNonmoving;
    Game_Player.prototype.updateNonmoving = function(wasMoving) {
        if ($gameMap.isEventRunning()) return;
        if (wasMoving) this._triggerEventActed = false;
        else $gameTemp.clearDestination();
        if (!this._triggerEventActed && this.canInput()) {
            this.checkEventTriggerHere([1,2]);
            this._triggerEventActed = true;
            if ($gameMap.setupStartingEvent()) return;
        }
        this.triggerAction();
    };
    
    //前方にトリガーイベントいるか
    Game_Player.prototype.areTriggerEventsInFront = function() {
        if (this.attackItem().object().meta.alwaysAttack) return false;
        var pfx = $gameMap.roundXWithDirection(this.x, this._direction);
        var pfy = $gameMap.roundYWithDirection(this.y, this._direction);
        return $gameSystem.areTriggerEventsXy(pfx, pfy);
    };
    
    //操作受付中かどうか
    Game_Player.prototype.canInput = function() {
        return !$gameSystem.inMenu() && this.canMove() &&
             this.isStopping() && $gameSystem.canMove() && $gamePlayer._DCount > 0;
    };
    
    Game_Player.prototype.checkEventTriggerThere = function(triggers) {
    };
    
    //-----------------------------------------------------------------------------
    // Game_Event
    //-----------------------------------------------------------------------------
    
    //初期化
    var _Game_Event_initialize = Game_Event.prototype.initialize;
    Game_Event.prototype.initialize = function() {
        _Game_Event_initialize.apply(this, arguments);
        this._startXy = [this.x, this.y];
    };
    
    //イベント初期化
    var _Game_Event_initMembers = Game_Event.prototype.initMembers;
    Game_Event.prototype.initMembers = function() {
        _Game_Event_initMembers.apply(this, arguments);
        this._DId       = 0;    //敵やアクターなどのID
        this._DType     = 0;    //1:敵 2:アクター 3:ギミック 4:アイテム 5:防具 6:金
        this._D         = null;
        
        this._gold = 0;
        this._move = 0;        //移動　0:陸のみ 1:壁抜け 2:壁ほり 3: 4:
        this._movePattern = 0; //行動　0:追跡 1:攻撃受けたら追跡 2:ランダム 3:逃走 4:固定
        this._item = null;
        this._name = '';
        this._attackMode = false;
        this._canTradePos = false;
        this._tradeDir = 0;
        this._destination = null;
        this._roomCount = 0;
    };
    
    //メモ欄と注釈からの読み取り・Dセット
    var _Game_Event_refresh = Game_Event.prototype.refresh;
    Game_Event.prototype.refresh = function() {
        if (!this.event()) return;
        _Game_Event_refresh.apply(this, arguments);
        this._important = !!this.event().meta.important;
        var a;
        if (!this._D) a = true;
        if (a) {
        
            if      (this.event().meta.enemy)    this._DId  = Number(this.event().meta.enemy),   this._DType = 1;
            else if (this.event().meta.actor)    this._DId  = Number(this.event().meta.actor),   this._DType = 2;
            else if (this.event().meta.gimmick)  this._DId  = Number(this.event().meta.gimmick), this._DType = 3;
            else if (this.event().meta.item)     this._DType = 4;
            else if (this.event().meta.armor)    this._DType = 5;
            else if (this.event().meta.gold)     this._DType = 6;
            if (this._DType === 4) {
                if (this._param.D) this._D = this._param.D;
    //            else this._DId = $gameSystem.randomItemId(1);
            }
            if (this._DType === 5) {
                if (this._param.D) this._D = this._param.D;
    //            else this._DId = $gameSystem.randomItemId(2);
            }
            if (this._DType === 6) {
                if (this._param.D) {
                    this._D = this._param.D, this._gold = this._D.gold;
                } else {
                    var goldInfo = $dataMap.meta.gold ? $dataMap.meta.gold.split('n') : [];
                    this._gold = rand(Number(goldInfo[0]) || 2, Number(goldInfo[1]) || 100);
                }
                this._gold = Math.round(this._gold * (1 + $gamePlayer._D.metaStateNum('goldPlusRate')));
            }
        }
        
        var page = this.page();
        if (page && this._lastPageIndex !== this._pageIndex) {
            this._lastPageIndex = this._pageIndex;
            for (var i = 0; i < page.list.length; i++) {
                if (page.list[i].code === 108 || page.list[i].code === 408) {
                    var text = page.list[i].parameters[0];
                    if (getMeta(text, 'move'))         this._move         = Number(getMeta(text, 'move'));
                    if (getMeta(text, 'movePattern'))  this._movePattern  = Number(getMeta(text, 'movePattern'));
                    if (getMeta(text, 'maxAction'))    this._maxAction    = Number(getMeta(text, 'maxAction'));
                    if (getMeta(text, 'maxAttack'))    this._maxAttack    = Number(getMeta(text, 'maxAttack'));
                    if (getMeta(text, 'name'))         this._name         = getMeta(text, 'name');
                    if (getMeta(text, 'nameByWeapon')) this._nameByWeapon = !!getMeta(text, 'nameByWeapon');
                    if (getMeta(text, 'canTradePos'))  this._canTradePos  = !!getMeta(text, 'canTradePos');
                    if (getMeta(text, 'NPC'))          this._NPC          = Number(getMeta(text, 'NPC'));
                    if (getMeta(text, 'powerUp'))      this._powerUp      = Number(getMeta(text, 'powerUp'));
                }
            }
            if (this._nameByWeapon) {
                var item = $gameSystem.newItem($gameSystem.getWeaponIdByName(this.event().meta.weapon));
                if (item) {
                    this._name = item.itemName();
                    this._nameWithSubName = item.itemName(0, 0, 1);
                    item = null;
                }
            } else if (this.event().meta.messageName) {
                var item = $gameSystem.newItem(Number(this.event().meta.messageName));
                if (item) this._nameWithSubName = item.itemName(0, 0, 1);
                item = null;
            } else {
                if (this._DType === 1 && !(this._DId >= 71 && this._DId < 81)) {
                    var item = $gameSystem.newItem($gameSystem.getWeaponIdByName(this.event().meta.weapon));
                    if (item) this._name = item.itemName();
                    item = null;
                }
            }
        }
        if (a) this.setD();
        if (!this._characterName && (!this.page() || !this.page().image.characterName)) {
            this._DType = 0;
            this._D = null;
        }
        if (a) {
            if (this.isCharacter()) {
                this._broad = this.event().meta.broad;
                if (!this._NPC) //敵は最初から敵対ON
                    this._attackMode = true;
                //ザコ敵の強化
                if (!this._powerUp && !this._NPC && this.isPrefab() && !$dataMap.meta.maojo) { 
                    var lv = $gameVariables.value(12).clamp(0, 4) + ($gameVariables.value(1) >= 201 ? 1 : 0);
                    this._powerUp = [0, 1.2, 1.4, 1.6, 1.8, 1.8][lv];
                }
                //開幕睡眠
                if (!NWS()._nextIsMonsterFloor && this._attackMode && 
                    (!Math.randomInt(12) || this.room() === 15) && 
                    this._D._enemyId !== 60) {
                    this._D.addState(9);
                }
                if (!this._NPC && $dataMap.meta.SBI) { //サバイバル島
                    this._important = true;
                    this.turnTowardPlayer();
                    this._broad = true;
                    this.setDestination([$gamePlayer.x, $gamePlayer.y]);
                    this._D.removeState(9);
                    this._powerUp = 3 + Math.floor(NWS()._turn / 4) / 10;
                    if (NWS()._turn > 150) this._powerUp += (NWS()._turn - 150) / 40;
                }
                this.setTarget();
                this._D._hp = this._D.mhp;
            }
            if (this._DType === 1) { //敵の設定
                //所持アイテム
    //            if (this._D.enemy().gold) {
    //                this._item = $gameSystem.newGold(this._D.enemy().gold);
    //            } else if (this._D.enemy().dropItems.length) {
    //                var item = this._D.makeDropItems()[0] || null;
    //                if (item) this._item = DataManager.isArmor(item) ?
    //                    $gameSystem.newArmor(item.id) : $gameSystem.newItem(item.id);
    //            }
                //開幕睡眠
                if (!NWS()._nextIsMonsterFloor && this._attackMode && 
                    (!Math.randomInt(12) || this.room() === 15) && 
                    this._D._enemyId !== 60) {
                    this._D.addState(9);
                }
            }
        }
    };
    
    Game_Event.prototype.setTarget = function() {
        this._target = $gamePlayer;
    };
    
    Game_PrefabEvent.prototype.locateWithoutStraighten = function(x, y) {
        this.setPosition(x, y);
        this.refreshBushDepth();
        if (this._param.jump) {
            this.itemJump(this._x, this._y);
        } else if (this._param.throw) {
            this._throwDirection = this._param.throwInfo[0];
            this._throwThrough = this._param.throwInfo[1];
            this._throwSpeed = this._param.throwInfo[2];
            NWS()._throwing = true;
        }
        if (this.isCharacter()) {
            this._opacity = 0;
            this._fadeOpacity = true;
        }
    };
    
    //攻撃スキルID
    Game_Event.prototype.attackItem = function() {
        return this._equip || $gameSystem.newItem(1);
    };
    
    Game_Event.prototype.itemJump = function(centerX, centerY) {
        var xy = this.findNoItemXy(centerX, centerY);
        if (xy) {
            this.jump(xy[0] - this._x, xy[1] - this._y);
        } else {
            this.jump(0, 0);
            this._extinct = true;
        }
    };
    
    Game_Event.prototype.selfSwitchCode = function() {
        var event = this.hasTemplate() ? $dataMap.events[this._eventId] : this.event();
        var xy = this._startXy || [];
        return [$gameMap.mapId(), xy[0], xy[1], this.event().meta.weapon];
    };
    
    Game_Event.prototype.needNotUpdateEvent = function() {
        return this.event() && !this._important && !this._D && 
            (this._moveRoute && this._moveRoute.list.length < 1) &&
            !this.isNearPlayer();
//        $gameMap.events().filter(function(a){return !a.needNotUpdateEvent()}).length
    };
    
    var _Game_Event_update = Game_Event.prototype.update;
    Game_Event.prototype.update = function() {
        if (!this.event() || (this.isCharacter() && !this._D)) return $gameMap.eraseEvent(this._eventId);
        if (this.needNotUpdateEvent()) {
            this._DCount = 0;
            return;
        }
        if (this.event().meta.weapon && !this.event().meta.noErase &&
            $gameSelfSwitches.value(this.selfSwitchCode())) $gameMap.eraseEvent(this._eventId);
//        if (this.isCharacter()) $gameMap.eraseEvent(this._eventId);
        _Game_Event_update.apply(this, arguments);
        if (this._fadeOpacity) {
            if (this._opacity >= 255) this._fadeOpacity = false;
            else this._opacity += 255 / 20;
        }
        if (this.isCharacter()) {
            if (!this._fixMoveSpeed)
                this.setMoveSpeed(Math.max($gamePlayer.realMoveSpeed() + this.turnActionNum() - 1, 4));
            if (!this._D.canMove()) this._DCount = 0;
            if (this._DCount > 0) this.action();
        } else if (this.isItem()) {
            this.updateItem();
            if (this._throwDirection) this.updateItemThrow();
            if (this._extinct && this.isStopping() && $gameMap._events[this._eventId]) {
                $gameSystem.displayUnshift('%1は消えてしまった。'.format(this.itemName(true, true)));
                $gameSystem.setDisplaySeUnshift('miss');
                $gameMap.eraseEvent(this._eventId);
            }
        }
        if (this._TurnTowardAfterMove && this.isStopping()) {//移動後ターゲットのほうを見る
            if (this._destination)
                this.turnTowardCharacter({x : this._destination[0], y : this._destination[1]});
            this._TurnTowardAfterMove = false;
        }
    };
    
    //行動決定
    Game_Event.prototype.decideAction = function() {
//        return this._DCount = 0;
        if (this._DType === 1) {
//            if (this._movePattern === 4) { //掃除屋の場合、ターゲットを近くの敵に設定
//                this._attackMode = true;
//                var events = [$gamePlayer].concat($gameMap.events()).filter(function(event) {
//                    var a = event && event._D && event._D._enemyId && event._D._enemyId === 60;
//                    var b = event && event.isCharacter() && !a;
//                    return !!b;
//                }, this);
//                var thisEvent = this;
//                this._target = events.reduce(function(p, c) {
//                    return thisEvent.distanceFrom(p) <= thisEvent.distanceFrom(c) ? p : c;
//                });
//            } else {
                if (NWS()._backCharacter.length && !this._backCharacter) {
                    var events = $gameMap.events().filter(function(ev) {
                        return ev && ev.isCharacter() && NWS()._backCharacter.contains(ev._backCharacter)
                    });
                    events.push($gamePlayer);
                    var thisEv = this;
                    events.sort(function(a, b) {
                        return thisEv.distanceFrom(a) - thisEv.distanceFrom(b);
                    });
                    if (events[0]) this._target = events[0];
                } else {
                    this.setTarget();
                }
//            }
            if (this._destination &&
                this.pos(this._destination[0], this._destination[1])) { //目的地ついたら目的地を消す
                this.setDestination(null);
            } else {
                if (--this._destCount <= 0) this.setDestination(null); //諦める
            }
            if (this._attackMode) {
                this.updateChasing(); //見つける処理
                if (this._destination) { //アクションを作成
                    if (this.distanceFrom(this._target) <= 1) this._D.addState(37); //距離1ステート付与・解除
                    else this._D.removeState(37);
                    this._D.makeActions();
                    if (this._D.currentAction().item() &&
                        this._D.currentAction().item().meta.byWeapon) { //武器攻撃
                        var action = new Game_Action(this._D);
                        action._item = this.attackItem();
                        this._D.setAction(0, action);
                    }
                    var skill = this._D.currentAction().item();
                    if (!skill || (this._D.currentAction() && !this._D.metaState('mustAttack') &&
                        ((Number(skill.meta.rangeType) || 0) !== 0 &&
                         !(this.inRange(skill, this._target))))) {
                        this._D.clearActions();
                    }
                }
            } else if (this._backCharacter) {
                this.updateChasing();
            }
            this._action = this._D.currentAction();
            if (this._DCount > 0) this.action(true); //条件が揃えばもう実行する
            else this._decidedAction = true;
        }
    };
    
    //行動
    Game_Event.prototype.action = function(noCheck) {
        if (!this.isStopping()) return;
        var acted = false;
        if (this._tradeDir) { //プレイヤーとの位置交換が予約済み
            this.moveStraight(this._tradeDir);
            if (!this.isMovementSucceeded()) this._DCount--;
            this._tradeDir = 0;
            return;
        }
        if (!noCheck && (!this._action || !this._action.item())) this.decideAction();
        if (!$gameSystem.isFlying() && this.pos($gamePlayer.x, $gamePlayer.y)) {//プレイヤーと重なった場合、抜け出すのが優先
            this._D.clearActions();
            this.setMovementSuccess(false);
            for (var i = 0; i < 8 && !this.isMovementSucceeded(); i++) this.moveRandom();
            if (!this.isMovementSucceeded()) this._DCount--;
        } else if (this._action && this._action.item()) {
            if (!NWS()._canAction || NWS()._cannotAction) return;
            $gameSystem.updateCanAction();
            if (!NWS()._canAction) return;
            this.startAction(this._action);
            acted = true;
        }
        if (!acted) { //移動
            if (this._movePattern === 0 || this._movePattern === 4) { //追跡
                if (this._destination) this.moveChase();
                else if (!(NWS()._turn % 2)) this.moveAlongPass(); //普段は1/2行動
                else this._DCount--;
            } else  if (this._movePattern === 2) { //逃走
                if (this.distanceFrom(this._target) <= 7) this.turnAwayFromPlayer();
                this.moveAlongPass();
            } else  if (this._movePattern === 3) { //フラフラ
                if (this._destination && !Math.randomInt(2)) {
                    this.moveChase();
                } else {
                    this.moveRandom();
                    if (!this.isMovementSucceeded()) this._DCount--;
                }
            } else { //固定
                this._DCount = 0;
            }
        }
    };
    
    //追跡判定
    Game_Event.prototype.updateChasing = function() {
        if (this._target._D.metaState('transparent') || //ステート_transparent
            $gameSystem.isFlying() //空飛んでる
           ) {
            this.setDestination(null);
        } else if (this._movePattern === 3) { //フラフラ移動では常にターゲットの位置を目的地に
            this.setDestination([this._target.x, this._target.y]);
        } else {
            if (this._attackMode || this._backCharacter) {
                var room = this.room(), tRoom = this._target.room();
//                if (this.distanceFrom(this._target) <= 2 || (room && ((tRoom && room === tRoom) ||
//                    ($gameMap.mapGenerator() && this._destination && 
//                        ((room.passXy.t && this._target.pos(room.passXy.t[0], room.passXy.t[1])) ||
//                         (room.passXy.b && this._target.pos(room.passXy.b[0], room.passXy.b[1])) ||
//                         (room.passXy.l && this._target.pos(room.passXy.l[0], room.passXy.l[1])) ||
//                         (room.passXy.r && this._target.pos(room.passXy.r[0], room.passXy.r[1])))))))
                var d = this._direction;
                var cx = $gameMap.roundXWithDirection($gameMap.roundXWithDirection(this.x, d), d);
                var cy = $gameMap.roundYWithDirection($gameMap.roundYWithDirection(this.y, d), d);
                var rId1 = this.regionId(), rId2 = this._target.regionId();
                var dis = this.event() && this._broad ? 20 : 5;
                if (this._target.distanceFrom({x : cx, y : cy}) <= Math.sqrt(dis) &&
                    !($gameSystem.inRoom() && rId1 !== 16 && rId2 === 16))
                { //見つけた
                    this.setDestination([this._target.x, this._target.y]);
                } else {
                    if (this._backCharacter) {
                        NWS()._backCharacter.splice(NWS()._backCharacter.indexOf(this._backCharacter), 1);
                        this._backCharacter = 0;
                    }
                }
            }
        }
    };
    
    //追跡移動
    Game_Event.prototype.moveChase = function() {
        var acted = false;
        this._TurnTowardAfterMove = true;
//        if (this._attackMode && this.distanceFrom(this._target) <= 4.5) {
//            for (var i = 0; i < 4; i++) { //スキルが届く場所の検索
//                var d = this._direction;
//                d = [d, [6, 2, 8, 4][d / 2 - 1], [4, 8, 2, 6][d / 2 - 1], 10 - d][i];
//                if (this.canPass(this.x, this.y, d) && this._D.enemy().actions.some(function(action) {
//                    var x = $gameMap.roundXWithDirection(this.x, d);
//                    var y = $gameMap.roundYWithDirection(this.y, d);
//                    return this._D.meetsCondition(action, true) &&
//                        this.inRange($dataSkills[action.skillId], this._target, x, y);
//                }, this)) {
//                    this.moveStraight(d);
//                    acted = true;
//                    break;
//                }
//            }
//        }
        if (!acted) { //届かない場合 近づく
            this.moveTowardDestination();
        }
    };
    // 適当移動
    Game_Event.prototype.moveAlongPass = function() {
//        var room = this.room();
//        if (!room) this._roomCount = -1;
//        else this._roomCount++;
//        if ($gameMap.mapGenerator() &&
//            ((this._roomCount === 0 && !Math.randomInt(3)) ||
//            (this._roomCount >= 5 && !Math.randomInt(40)))) { //そろそろ部屋出るか
//            var xyList = [];
//            for (var i = 0; i < 4; i++) {
//                var pass = room.passXy[['t', 'b', 'l', 'r'][i]];
//                if (pass) xyList.push(pass);
//            }
//            if (xyList.length) {
//                this.setDestination(xyList[Math.randomInt(xyList.length)]);
//                this.moveTowardDestination();
//                return;
//            }
//        }
        
        //ウロウロ・通路移動
        var candidateD = [], d = this._direction;
        for (var i = 0; i < 3; i++) {
            if (i === 1) d = [[6, 2, 8, 4][d / 2 - 1], [4, 8, 2, 6][d / 2 - 1]][Math.randomInt(2)];
            else if (i === 2) d = 10 - d;
            if (this.canPass(this._x, this._y, d)) for (var j = 0; j < (i === 0 ? 5 : 1); j++) candidateD.push(d);
        }
        if (candidateD.length) this.moveStraight(candidateD[Math.randomInt(candidateD.length)]);
        else this.moveStraight(10 - this._direction);
        if (!this.isMovementSucceeded()) this._DCount--;
    };
    
    //目的地へ向かって進む処理
    Game_Event.prototype.moveTowardDestination = function() {
        var ch = {x : this._destination[0], y : this._destination[1]};
        if ((true || this._backCharacter) && this.distanceFrom(ch) > 1)
            this.moveTowardCharacter({
                x : $gameMap.roundXWithDirection($gamePlayer._x, 10 - $gamePlayer._direction),
                y : $gameMap.roundYWithDirection($gamePlayer._y, 10 - $gamePlayer._direction)
            });
        else this.moveTowardCharacter(ch);
        if (!this.isMovementSucceeded()) {
            if (this.distanceFrom({x : this._destination[0], y : this._destination[1]}) <= 1) {
                this._DCount--;
                return;
            }
            this.turnRightOrLeft90();
            this.moveForward();
            if (!this.isMovementSucceeded()) {
                this._DCount--;
            }
        }
    };
    
    Game_CharacterBase.prototype.setDestination = function(destination) {
        if (!destination) {
            this._destination = null;
            this._destCount = 0;
        } else {
            this._destination = destination;
            this._destCount = 5;
        }
    };
    
    var _Game_Event_moveStraight = Game_Event.prototype.moveStraight;
    Game_Event.prototype.moveStraight = function(d) {
        if (this.isCharacter() && this._D.metaState('confuse')) //ステート_confuse
            d = [2, 4, 6, 8][Math.randomInt(4)];
        _Game_Event_moveStraight.call(this, d);
    };
    
    //武器画像名取得
    Game_Event.prototype.getWeaponImageName = function() {
        if (!this.event() || !this.event().meta.weapon) return '';
        var id = $gameSystem.getWeaponIdByName(this.event().meta.weapon);
        var alpha = this.event().meta.weaponImage || '';
        return 'Weapon_' + id + alpha;
    };
    
    //アイテム入手
    Game_Event.prototype.getItem = function(item) {
        this._item = item;
    };
    //アイテム消去
    Game_Event.prototype.eraseItem = function(item) {
        this._item = null;
    };
    
    //アイテム拾われる処理
    Game_Event.prototype.pickedUpItem = function(event) {
        var special = $gameVariables.value(9);
        if (special >= 13 && special < 21 && !NWS()._tutorialValue.contains(this._itemTId))
            NWS()._tutorialValue.push(this._itemTId);
        if (this._DType === 6) $gameSystem.setDisplaySe('gold');
        else $gameSystem.setDisplaySe('item');
        var text = '%1は%2を拾った！'.format(event._D.name(), this.itemName(true, true));
        $gameSystem.display(text, 0, 0, 0, 0, 6);
        event.getItem(this._D);
        $gameMap.eraseEvent(this._eventId);
        return true;
    };
    
    //アイテム更新
    Game_Event.prototype.updateItem = function() {
        this._customPriority = this.isStopping() ? 1.1 : 5.1;
    };
    //アイテム投げ更新
    Game_Event.prototype.updateItemThrow = function() {
        this._shadow = false;
        this._moveSpeed = this._throwSpeed || 5.0;
        this._stepAnimeSpeed = 3;
        this._customPriority = 3.5;
        if (!this.isMoving()) {
            if (!this._throwStartXy) this._throwStartXy = [this.x, this.y].toString();
            if (this._throwStartXy === [this.x, this.y].toString()) { //最初は必ず前進させる
                this.moveStraight(this._throwDirection);
                return;
            }
            if (!$gameSystem.isGround(this.x, this.y)) {  //壁に衝突
//                this.isCollidedWithCharacters(this.x, this.y)) { //または地形イベントに衝突
                var x = $gameMap.roundXWithDirection(this.x, this.reverseDir(this._throwDirection));
                var y = $gameMap.roundYWithDirection(this.y, this.reverseDir(this._throwDirection));
                this._shadow = true;
                this._moveSpeed = 3;
                this._customPriority = 0;
                this._throwDirection = 0;
                NWS()._throwing = false;
                if (this._D.object() && this._D.object().meta.delete) {
                    $gameMap.eraseEvent(this._eventId);
                } else {
                    $gameSystem.playDisplaySe('item');
                    $gameSystem.display('%1は地面に落ちた！'.format(this.itemName(1, 1)));
                    this.itemJump(x, y);
                }
            } else {
                var event = [$gamePlayer].concat($gameMap.events()).filter(function(ev) {
                    return ev && ev.isCharacter() && ev.pos(this.x, this.y);
                }, this)[0];
                if (event) { //キャラに衝突
                    if (this._D.object().meta.collideSkillId) { //スキル発動
                        event.useSkill(Number(this._D.object().meta.collideSkillId));
                    } else { // 武器投げが当たった
                    }
                    if (!this._throwThrough) {
                        $gameMap.eraseEvent(this._eventId);
                        NWS()._throwing = false;
                    } else {
                        this.moveStraight(this._throwDirection);
                    }
                } else {
                    this.moveStraight(this._throwDirection);
                }
            }
        }
        if (!this.isMovementSucceeded() || this.isOutOfScreen()) {
            $gameMap.eraseEvent(this._eventId);
            NWS()._throwing = false;
        }
    };
    
    //特定のmetaアイテムを持っているか
    Game_Event.prototype.metaItem = function(metaName) {
        if (this._item && !this._item._gold && this._item.object().meta[metaName]) return this._item;
        else return null;
    };
    
    //死ぬ処理
    Game_Event.prototype.dead = function() {
        if (!Game_CharacterBase.prototype.dead.apply(this, arguments)) return false;
        if (this._backCharacter) {
            NWS()._backCharacter.splice(NWS()._backCharacter.indexOf(this._backCharacter), 1);
            this._backCharacter = 0;
        }
        this._transparent = true;
        this._additionalX = this._lastParam, this.setMotion();
        if (!$dataMap.meta.SBI) {
            NWS()._turnExp += this._exp || 0;
            NWS()._turnGold += this._gold || 0;
        }
//        if (this._item) {
//            $gameSystem.putItem(this._item, this._x, this._y);
//            $gameSystem.setDisplaySe('itemDrop');
//            $gameSystem.displayUnshift('%1は%2を落とした。'.format(this._D.name(), this._item.itemName(1, 1)));
//        }
        if ($dataMap.meta.SBI && this._exp) {
            var scorePlus = this._exp * 5 / $gameSystem.sisterParam(0);
            $gameVariables.setValue(30, $gameVariables.value(30) + scorePlus);
        }
        if (!$gameMap.eventsXy(this.x, this.y).some(function(ev) {return ev && ev.event() && ev.event().meta.noItemOn})) {
            if (!Math.randomInt(16)) { //薬草を落とす
                $gameMap.spawnEvent(33, this.x, this.y, true, {jump:true});
                $gameMap.rejudgeEvents();
                $gameSystem.setDisplaySe('itemDrop');
                var text = ['%1は\\i[261]薬草を落とした！', 'The %1 dropped an \\i[261]herb!',
                            '%1는 \\i[261]약초를 떨어뜨렸다!', '%1掉落\\i[261]藥草了！', '%1掉落了\\i[261]药草！'][_lg()];
                $gameSystem.display(text.format(this._D.name()));
            } else if (!Math.randomInt(8) || ($dataMap.meta.SBI && !Math.randomInt(3))) { //アルマの石を落とす
                $gameMap.spawnEvent(14, this.x, this.y, true, {jump:true});
                $gameMap.rejudgeEvents();
                $gameSystem.setDisplaySe('itemDrop');
                var text = ['%1は\\i[141]アルマの石を落とした！', 'The %1 dropped an \\i[141]Arma Stones!',
                            '%1 \\i[141] 알마 돌을 떨어뜨렸다!', '%1掉落\\i[141]魂石了！', '%1掉落了\\i[141]魂石！'][_lg()];
                $gameSystem.display(text.format(this._D.name()));
            }
        }
        if (this._param.regionId) {
            $gameMap.numRegionEnemies(this._param.regionId, -1);
        }
        $gameVariables.setValue(17, $gameVariables.value(17) - 1);
        this._DCount = 0;
        if (this._deadCode) $gameSelfSwitches.setValue(this._deadCode, true)
        $gameMap.eraseEvent(this._eventId);
    };
    
    //敵対中は話しかけられない処理
    var _Game_Event_start = Game_Event.prototype.start;
    Game_Event.prototype.start = function() {
        if (!NWS()._gettingWeapon && this._attackMode) return;
        _Game_Event_start.apply(this, arguments);
    };
    
    //-----------------------------------------------------------------------------
    // Game_Battler関連
    //-----------------------------------------------------------------------------
    
    //名前 優先度は meta > データベース
    var _Game_Enemy_name = Game_Enemy.prototype.name;
    Game_Enemy.prototype.name = function() {
        if (this._event) {
            if (this._event._name) return this._event._name;
        }
        return _Game_Enemy_name.apply(this, arguments);
    };
    var _Game_Actor_name = Game_Actor.prototype.name;
    Game_Actor.prototype.name = function() {
        return (this._event && this._event._name) ? this._event._name : _Game_Actor_name.apply(this, arguments);
    };
    
    Game_BattlerBase.prototype.meetsSkillConditions = function(skill) {
        return !this.isSkillTypeSealed(skill.stypeId);
    };
    Game_BattlerBase.prototype.meetsItemConditions = function(item) {
        return true;
    };
    
    var _Game_BattlerBase_isSkillTypeSealed = Game_BattlerBase.prototype.isSkillTypeSealed;
    Game_BattlerBase.prototype.isSkillTypeSealed = function(stypeId) {
        return _Game_BattlerBase_isSkillTypeSealed.apply(this, arguments);
    };
    
    //ステート判定の変更　hp<=0のときはステートつけない
    var _Game_Battler_isStateAddable = Game_Battler.prototype.isStateAddable;
    Game_Battler.prototype.isStateAddable = function(stateId) {
        return this._hp > 0 && _Game_Battler_isStateAddable.apply(this, arguments);
    };
    //死亡ステートついてもHP0にしない
    Game_BattlerBase.prototype.addNewState = function(stateId) {
//        if (stateId === this.deathStateId()) {
//            this.die();
//        }
        var restricted = this.isRestricted();
        this._states.push(stateId);
        this.sortStates();
        if (!restricted && this.isRestricted()) {
            this.onRestrict();
        }
    };
    
    //死亡判定の変更
    Game_BattlerBase.prototype.isDead = function() {
        return this.hp <= 0 && !this._reviving;
    };
    Game_BattlerBase.prototype.isAlive = function() {
        return !this.isDead();
    };
    
    //特定のmetaのステートにかかっているか(traitsを参照　防具のmetaも適用)
    Game_BattlerBase.prototype.metaState = function(metaName) {
        var _object = null;
        this.traitObjects().forEach(function(object) {
            if (object.meta[metaName]) _object = object;
        })
        return _object;
    };
    //特定のmetaの合計を取得　true→1に換算(traitsを参照　防具のmetaも適用)
    Game_BattlerBase.prototype.metaStateNum = function(metaName) {
        var num = 0;
        this.traitObjects().forEach(function(object) {
            if (Number(object.meta[metaName])) num += Number(object.meta[metaName]);
        })
        return num;
    };
    
    Game_Actor.prototype.paramPlus = function(paramId) {
        var value = Game_Battler.prototype.paramPlus.call(this, paramId);
        NWS()._equips.forEach(function(item) {
            if (item.isArmor()) value += item.params(paramId);
        });
        if (paramId === 0) value += Math.max($gameSystem.sisterParam(6) - 120, 0);
//        if (paramId === 3) value += $gameSystem.sisterParam(1) - 1;
        return value;
    };
    var _Game_Actor_xparam = Game_Actor.prototype.xparam;
    Game_Actor.prototype.xparam = function(xparamId) {
        var value = _Game_Actor_xparam.apply(this, arguments);
        if (xparamId === 1) value += ($gameSystem.sisterParam(8, 2) - 5) / 100;
        return value;
    };
    
    Game_Actor.prototype.traitObjects = function() {
        var objects = Game_Battler.prototype.traitObjects.call(this);
        objects = objects.concat([this.actor(), this.currentClass()]);
        NWS()._equips.forEach(function(item) {
            if (item.isArmor()) objects.push(item.object());
        });
        return objects;
    };
    
    //特定のmeta装備を装備中か
    Game_Battler.prototype.metaEquips = function(metaName) {
        return this.equips().filter(function(item) {
            return !!item.meta[metaName];
        })[0] || null;
    };
    
    //敵のパラメータ参照位置をいじる
    var _Game_Enemy_paramBase = Game_Enemy.prototype.paramBase;
    Game_Enemy.prototype.paramBase = function(paramId) {
        var value = _Game_Enemy_paramBase.apply(this, arguments);
        //攻撃力を武器データから参照
        if (paramId === 2 && this.enemy().meta.paramByWeapon && this._event &&
            this._event.event() && this._event.event().meta.weapon) {
            var id = $gameSystem.getWeaponIdByName(this._event.event().meta.weapon);
            value = $gameSystem.newItem(id).power();
        }
        //ステータスをパワーアップ
        if (this._event && this._event._powerUp) {
            if ([0].contains(paramId)) value *= Math.pow(this._event._powerUp, 0.9);
            if ([2].contains(paramId)) value *= Math.pow(this._event._powerUp, 0.4);
        }
        
        return Math.ceil(value);
    };
    
    //死亡ステートはつけない
    Game_Battler.prototype.refresh = function() {
        Game_BattlerBase.prototype.refresh.call(this);
    };
    
    //レベルアップメッセージ
    Game_Actor.prototype.displayLevelUp = function(newSkills) {
        if (this._actorId !== 1) return;
        this.gainHp(9999);
        $gameSystem.display('', $gamePlayer, 0, null, 'levelUp');
    };
    
    //Mp回復時にステート「スタミナ切れ」を回復
    var _Game_Battler_gainMp = Game_Battler.prototype.gainMp;
    Game_Battler.prototype.gainMp = function(value) {
        _Game_Battler_gainMp.apply(this, arguments);
        if (this.mp > 0) this.removeState(18);
    };
    
    //ステート自動解除　autoRemoveJustPlayerを適用
    Game_Battler.prototype.removeStatesAuto = function(timing) {
        this.states().forEach(function(state) {
            if (this.isStateExpired(state.id) && state.autoRemovalTiming === timing &&
                !(state.meta.autoRemoveJustPlayer && this.isEnemy())) {
                this.removeState(state.id);
            }
        }, this);
    };
    
    //敵の弱点属性を取得
    Game_BattlerBase.prototype.weakElements = function() {
        if (!this.isEnemy() || !this.enemy().meta.weak) return [];
        return this.enemy().meta.weak.split(',').map(function(el) {return Number(el)});
    };
    //敵の耐性属性を取得
    Game_BattlerBase.prototype.resistElements = function() {
        if (!this.isEnemy() || !this.enemy().meta.resist) return [];
        return this.enemy().meta.resist.split(',').map(function(el) {return Number(el)});
    };
    
    //死んだときにステート解除表示を防ぐ
    var _Game_Battler_removeStatesByDamage = Game_Battler.prototype.removeStatesByDamage;
    Game_Battler.prototype.removeStatesByDamage = function() {
        if (this.isDead()) return;
        _Game_Battler_removeStatesByDamage.apply(this, arguments);
    };
    
    //-----------------------------------------------------------------------------
    // Game_Action
    //-----------------------------------------------------------------------------
    
    Game_Action.prototype.setSubject = function(subject) {
        this._subject = subject;
    };
    Game_Action.prototype.subject = function() {
        return this._subject;
    };
    
    //ダメージ計算変更
    Game_Action.prototype.evalDamageFormula = function(target) {
        try {
            var item = this.item();
            var a = this.subject();
            var b = target;
            var _item = this._item;
            
            var attack = a.atk;
            attack *= 1 - b._buffs[3] / 3;
            var damB = (
                attack * 3 * Math.pow(0.1, b.def / attack)
                       ).clamp(1, 9999); //基本ダメージ
            var damC = 20 + a.level; //レベル依存固定ダメージ
            var damW = function(power) { //武器によるダメージ　引数は武器の威力
                var attack = power * a.paramRate(2) * a.paramBuffRate(2);
                var value = (
                    attack * 3 * Math.pow(0.1, b.def / power)
                ).clamp(1, 9999);
                if (item.repeats > 1) value *= 1 - (item.repeats - 1) * 0.08;
                return value;
            }
            var damM = function(power) { //魔法によるダメージ　引数は魔法の威力
                return ((power - b.mdf) * 3).clamp(1, 9999);
            }
            var damN = function(power) { //無属性によるダメージ
                return power * 3 * 0.6;
            }
            
            var v = $gameVariables._data;
            var sign = ([3, 4].contains(item.damage.type) ? -1 : 1);
            var value = Math.max(eval(item.damage.formula), 0) * sign;
            if (_item._togi) value *= 1.2;
            if (isNaN(value)) value = 0;
            return value;
        } catch (e) {
            _p(e)
            return 0;
        }
    };
    
    //バフのレート変更
    Game_BattlerBase.prototype.paramBuffRate = function(paramId) {
        var value = 1 + this._buffs[paramId] / 3;
        if (paramId === 3) { //防御
//            return Math.max((this.def + this._buffs[paramId] * 5) / this.def, value);
            return 1;
        }
        return value;
    };
    
    //属性計算の変更
    var _Game_Action_calcElementRate = Game_Action.prototype.calcElementRate;
    Game_Action.prototype.calcElementRate = function(target) {
        if (this.item().meta.dependEquip) 
            return target.elementRate(this.subject()._event.attackItem().object().damage.elementId);
        var rate = _Game_Action_calcElementRate.apply(this, arguments);
        var id = this.item().damage.elementId;
        if (id < 0) return rate;
        //弱点・耐性処理
        if (target.weakElements().contains(id)) rate *= 5, target._weak = true;
        else if (target.resistElements().contains(id)) rate *= 0.5, target._resist = true;
        else if ([2, 3, 4, 5, 6].contains(id)) rate *= 1.1;
        //天候の影響
        if (NWS()._weather === 1) rate *= id === 2 ? 2 : id === 3 ? 0.5 : 1;
        if (NWS()._weather === 2) rate *= id === 3 ? 2 : id === 2 ? 0.5 : 1;
        if (NWS()._weather === 3) rate *= id === 4 ? 2 : id === 2 ? 0.5 : 1;
        if (NWS()._weather === 4) rate *= id === 5 ? 2 : id === 6 ? 0.5 : 1;
        if (NWS()._weather === 5) rate *= id === 6 ? 2 : id === 5 ? 0.5 : 1;
        return rate;
    };
    
    //ダメージ決定時の色々
    var _Game_Action_makeDamageValue = Game_Action.prototype.makeDamageValue;
    Game_Action.prototype.makeDamageValue = function(target, critical) {
        var value = _Game_Action_makeDamageValue.apply(this, arguments);
        if (this.checkDamageType([1, 5]) && value > 1 &&
            target.isEnemy() && target.enemy().meta.allDamagesAre1) value = 1; //1しか喰らわない　掃除屋
        if (this.subject()._event.isPlayer() && target.isEnemy() && 
            target.enemy().meta.needsFire && $dataMap.meta.needsFire && !$gamePlayer._weaponFire) value = 0;
        return value;
    };
    //通常ダメージ時の処理いろいろ
    var _Game_Action_executeHpDamage = Game_Action.prototype.executeHpDamage;
    Game_Action.prototype.executeHpDamage = function(target, value) {
        _Game_Action_executeHpDamage.apply(this, arguments);
        var data = this._item.object();
        //ステート_infect
        var infect = target.metaState('infect');
        if (infect && $dataStates.contains(infect) && data.meta.touchAttack) {
            if (infect) this.subject().addState(infect.id);
        }
        //HP1耐え
        if (target.metaState('immortality') || 
            (target.isActor() && this._item.object().meta.immortality) ||
            (target.isActor() && $gameVariables.value(9) > 0) ||
            this._item.object().meta.mineuchi)
            target._hp = Math.max(target.hp, 1);
        if (this.subject()._event.isPlayer() && target.isEnemy()) { //攻撃受けたときの対応の変化
            if (target._event._NPC === 1) { //NPC追跡
                target._event._movePattern = 0;
                target._event._destination = [$gamePlayer.x, $gamePlayer.y];
            }
            if (target._event._NPC === 2) target._event._movePattern = 2; //NPC逃走
            target._event._attackMode = true; //攻撃による敵対ON
        }
    };
    
    Game_Battler.prototype.maxSlipDamage = function() {
        return $dataSystem.optSlipDeath ? Infinity : Math.max(this.hp - 1, 0);
    };
    
    //クリティカル判定変更
    var _Game_Action_itemCri = Game_Action.prototype.itemCri;
    Game_Action.prototype.itemCri = function(target) {
        var item = this.item().meta.dependEquip ? this.subject()._event.attackItem().object() : this.item();
        //ここで耐久値減少判定用も行う
        var result = target.result();
        if (result.isHit() && this._byPlayerWeapon) {
            if (this._isFirst && $gameSystem.sisterParam(8) > Math.randomInt(100)) NWS()._loseUseable = true;
            if (NWS()._loseUseable && NWS()._equip._useable <= 1) return 1;
        }
        
        if (item.meta.critical || this._byThrowingWeapon) return 1;
        var value = _Game_Action_itemCri.apply(this, arguments);
        if (value > 0 && item._togi) value *= 4;
        return value;
    };
    //クリティカル倍率変更
    Game_Action.prototype.applyCritical = function(damage) {
        return damage * 2;
    };
    
    //命中率
    var _Game_Action_itemHit = Game_Action.prototype.itemHit;
    Game_Action.prototype.itemHit = function(target) {
        var value = _Game_Action_itemHit.apply(this, arguments);
        if (this.subject().metaState('lockOn') || this._byThrowingWeapon) value = 1;
        return value;
    };
    //回避率
    var _Game_Action_itemEva = Game_Action.prototype.itemEva;
    Game_Action.prototype.itemEva = function(target) {
        var value = _Game_Action_itemEva.apply(this, arguments);
        if (this.subject().metaState('lockOn') || this._byThrowingWeapon) value = 0;
        return value;
    };
    
    //回数
    var _Game_Action_numRepeats = Game_Action.prototype.numRepeats;
    Game_Action.prototype.numRepeats = function() {
        var repeats = _Game_Action_numRepeats.apply(this, arguments);
        if (this.item().meta.dependEquip) 
            repeats = this.subject()._event.attackItem().object().repeats;
        return Math.floor(repeats);
    };
    
    Game_Action.prototype.itemEffectAddDebuff = function(target, effect) {
        var chance = target.debuffRate(effect.dataId) * this.lukEffectRate(target);
        if (this.item().damage.type > 0) {
            chance = (Number(this.item().meta.debuffRate) || 50) / 100;
        }
        if (this._byThrowingWeapon) chance *= 2;
        if (this.subject().metaState('lockOn')) chance = 1;
        if (Math.random() < chance) {
            target.addDebuff(effect.dataId, effect.value1);
            this.makeSuccess(target);
        }
    };
    
    Game_Action.prototype.itemEffectAddNormalState = function(target, effect) {
        var chance = effect.value1;
        if (!this.isCertainHit()) {
            chance *= target.stateRate(effect.dataId);
            chance *= this.lukEffectRate(target);
        }
        if (this._byThrowingWeapon) chance *= 2;
        if (this.subject().metaState('lockOn')) chance = 1;
        if (Math.random() < chance) {
            target.addState(effect.dataId);
            this.makeSuccess(target);
        }
    };

    Game_Action.prototype.itemEffectRemoveState = function(target, effect) {
        var chance = effect.value1;
        if (this._byThrowingWeapon) chance *= 2;
        if (this.subject().metaState('lockOn')) chance = 1;
        if (Math.random() < chance) {
            target.removeState(effect.dataId);
            this.makeSuccess(target);
        }
    };
    
    
    //-----------------------------------------------------------------------------
    // Game_Item
    //-----------------------------------------------------------------------------
    
    var _Game_Item_initialize = Game_Item.prototype.initialize;
    Game_Item.prototype.initialize = function(item) {
        _Game_Item_initialize.apply(this, arguments);
        this._useable = 0;
        this._maxUseable = 0;
        this._lastUsable = 0;
        this._gold = 0;
        this._inside = [];
        this._maxInside = 0;
        this._requestErase = false;
        this._level = 1;
        this._name = '';
        this._iconIndex = 0;
        this._togi = 0;
        this._mekki = 0;
        this._children = [];
        this._mixed = false;
        this.__switchName = '';
        this._detail = false;
        this._got = false;
        this._imageName = '';
        this._lock = false;
        this._lastUsedId = 0;
        this._getId = 0;
        this._noRevival = false;
    };
    
    var _Game_Item_setObject = Game_Item.prototype.setObject;
    Game_Item.prototype.setObject = function(item) {
        _Game_Item_setObject.apply(this, arguments);
        if (this.object()) {
            var meta = this.object().meta;
            this._useable = this._maxUseable = this._lastUseable = meta.useable || 5;
            this._level = 1;
        }
    };
    
    //アイテムID
    Game_Item.prototype.itemId = function() {
        return Number(this.object().meta.itemId) || this._itemId;
    };
    //アイテム名
    Game_Item.prototype.itemName = function(withIcon, withNum, withSubName) {
        var text = '', isGlod = !!this._gold;
        if (withIcon) text += '\\i[%1]'.format(this.iconIndex());
        var name = this._name || this.object().trueName || this.object().name;
        text += name;
        if (withSubName && this.object().subName) text += ' ' + this.object().subName;
//        if (this.isArmor() && this.object().etypeId <= 3) text += 'Lv.' + this._level;
//        if (withNum && this._useable > 0) text += ' (%1)'.format(this._useable);
//        if (withNum && this._maxInside) text += ' (%1/%2)'.format(this._inside.length, this._maxInside);
        return text;
    };
    //アイテムiconIndex
    Game_Item.prototype.iconIndex = function() {
//        return this._iconIndex || (!this._gold ? this.object().iconIndex : goldIconIndex);
        var value = this._itemId ? this._itemId + 1000 : 0;
        if (this._imageName) value += this._imageName;
        return value;
    };
    //アイテム説明
    Game_Item.prototype.itemDescription = function(space) {
        var text ='', slotText = '', dArray = [], object = this.object();
        if (this._gold) {
            text = 'お金だ。投げたりしないように。';
        } else if (this.isArmor()) {
            dArray = object.description.split('\n');
            text = '%1消費スロット：%2 \n防御力 +%3%4%5'.format(
                dArray[0], this._slot,
                this.params(3), dArray[1] ? ' / ' + dArray[1] : '',
                object.etypeId <= 3 ? ' / 最大Lv：' + this._maxLevel : ''
            )
        } else {
            text = object.description;
        }
        return text;
    };
    //価格
    Game_Item.prototype.price = function(noSister) {
        var price = this.object().price;
        price *= 1 + (this._level - 1) / 10;
        if (this._togi) price *= 1.2;
        if (this._mekki) price *= 1.5;
        if (!noSister) price *= $gameSystem.sisterParam(3);
        return Math.ceil(price);
    };
    Game_Item.prototype.makePrice = function() { //作成費用
        return Math.ceil(this.price(true) * 3 / 4);
    };
    
    //読みかた
    Game_Item.prototype.reading = function() {
        if (_lg()) return this.object().trueName + (this.object().subName || '');
        return (this.object().meta.reading || this.object().name) + (this.object().subName || '');
    };
    
    Game_Item.prototype.needArma = function() { //強化に必要なアルマの石
        var price = this.object().price;
        var power = (Number(this.object().meta.power) || 0) * this.object().repeats;
        var value = (price / 4000 + power / 10).clamp(1, 9);
        value *= Math.pow(1.1, (this._level - 1) / 2.86);
        value += this._level - 1;
        value = Math.round(value).clamp(2, 99);
        return value;
    };
    
    //武器画像名
    Game_Item.prototype.imageName = function() {
        return 'Weapon_' + this._itemId + this._imageName;
    };
    
    //レベルによる増減を加味したパラメーター
    Game_Item.prototype.params = function(paramId) {
        if (!this.isArmor()) return 0;
        var param = this.object().params[paramId];
        if (paramId === 3) param += this._level - 1;
        return param;
    };
    //レベルによる増減を加味したpower
    Game_Item.prototype.power = function() {
        var power = Number(this.object().meta.power);
        if (power) {
            power += this._level - 1;
            power += $gameSystem.sisterParam(7) || 0;
        }
        return power;
    };
    
    //効果テキスト
    Game_Item.prototype.effectText = function(texts) {
        texts = texts || this.object().meta.effectTexts || [];
        texts = texts.filter(function(t) {return t});
        if (!texts[0]) return '';
        var a = ' \\}▶ \\{'
        return a + texts.reduce(function(p, c) {
            return p + '\n' + a + c;
        })
    };
    
    //しまう/取り出す
    Game_Item.prototype.pushItem = function(item) {
        if (!item || this._maxInside <= 0) return;
        if (this._inside.length < this._maxInside) {
            this._inside.push(item);
            $gameSystem.setDisplaySe('item');
            $gameSystem.display('%1 を%2 の中に入れた。'.format(item.itemName(true, true), this.itemName(true)));
            return true;
        } else {
            $gameSystem.setDisplaySe('miss');
            $gameSystem.display('%2 の容量がいっぱいだ。%1 は入らなかった。'.format(item.itemName(true, true), this.itemName(true)));
            return false;
        }
    };
    Game_Item.prototype.takeOutItem = function(item) {
        if (!item || this._maxInside <= 0) return;
        if (!$gameSystem.itemMax()) {
            $gamePlayer.getItem(item);
            $gameSystem.setDisplaySe('item');
            $gameSystem.display('%1 を%2 から取り出した。'.format(item.itemName(true, true), this.itemName(true)));
            return true;
        } else {
            $gameSystem.setDisplaySe('miss');
            $gameSystem.display('持ち物がいっぱいだ。%1 を取り出せなかった。'.format(item.itemName(true, true)));
            return false;
        }
    };
    
    //使用回数の減少
    Game_Item.prototype.use = function(user) {
        if (this._gold || ['容器1', '容器2'].indexOf(this._type) >= 0) return; //お金・容器は使用不可
        if (['草', '食品'].indexOf(this._type) >= 0) this._requestErase = true;
        if (['石'].indexOf(this._type) >= 0) {
            if (--this._useable <= 0) {
                this._requestErase = true;
                var caId = 26; //砕け散るアニメID
                $gameSystem.display('%1 は砕け散った！'.format(this.itemName(true)), user, caId);
            }
        }
        if (['薬'].indexOf(this._type) >= 0) {
            if (--this._useable <= 0) {
                this._requestErase = true;
                $gameSystem.setDisplaySe('miss');
                $gameSystem.display('%1 を使い切った。'.format(this.itemName(true)));
            }
        }
    };
    
    //装備の強化
    Game_Item.prototype.strengthen = function() {
        this._level = Math.min(this._level + 1, this._maxLevel);
    };
    
    //装備の修理
    Game_Item.prototype.repair = function(noMessage) {
        if (this._useable >= this._maxUseable) {
            if (!noMessage) {
                $gameSystem.setDisplaySe('miss');
                var text = ['%1 は既にピカピカだ。', 'There is no need for repairing %1.',
                            '%1을 수리 할 필요는 없다.', '無需修復%1。', '无需修复%1。'][_lg()];
                $gameSystem.display(text.format(this.itemName(true)));
            }
        } else {
            this._useable = this._maxUseable;
            this._lastUseable = this._useable;
            if (!noMessage) {
                $gameSystem.setDisplaySe('flash');
//                if (!noMessage) $gameSystem.display(text.format(this.itemName(true)));
            }
        } 
    };
    
    //-----------------------------------------------------------------------------
    // Scene_Map
    //-----------------------------------------------------------------------------
    
    var _Scene_Map_initialize = Scene_Map.prototype.initialize;
    Scene_Map.prototype.initialize = function() {
        _Scene_Map_initialize.apply(this, arguments);
        this._flag = 0;
        this._actionOrder = [];
        this._acting = null;
        this._displayOrder = [];
        this._displayCount = 0;
        this._screenCount = 0;
        this._reservedActions = [];
        this._count = 0;
        //console.log(this);
    };
    
    //タッチで敵に攻撃するやつ
    var _Scene_Map_processMapTouch = Scene_Map.prototype.processMapTouch;
    Scene_Map.prototype.processMapTouch = function() {
        if (!$gamePlayer.canInput() || this.isTouchedInsideButton()) return;
        if ($gameVariables.value(9) === 5) return; //チュートリアル
        if (TouchInput.isTriggered()) {
            var x = $gameMap.canvasToMapX(TouchInput.x);
            var y = $gameMap.canvasToMapY(TouchInput.y);
            var d = $gamePlayer._direction;
            var event = $gameSystem.isFlying() ? null :
                $gameMap.eventsXy(x, y).filter(function(event) {
                    return event && event.isCharacter() && !(event._movePattern === 1 && !event._attackMode);
                })[0];
            for (var i = 0; i < 2; i++) { //そのままの向き、対象のほうへの向きで２回判定
                if (i === 1) {
                    $gamePlayer.turnTowardCharacter({x : x, y : y}); //２回目は対象を向かせる
                    if (d === $gamePlayer._direction) { //１回めと同じ向きならおしまい
                        if (event) return; else break;
                    }
                    d = $gamePlayer._direction;
                }
                if ($gamePlayer.distanceFrom({x : x, y : y}) === 1 &&
                    $gamePlayer._direction === $gamePlayer.getTowardCharacter({x : x, y : y}) &&
                    $gamePlayer.areTriggerEventsInFront()) { //目の前の起動イベントをタッチした場合
                    var x = $gameMap.roundXWithDirection($gamePlayer.x, $gamePlayer._direction);
                    var y = $gameMap.roundYWithDirection($gamePlayer.y, $gamePlayer._direction);
                    $gamePlayer.startMapEvent(x, y, [0], true);
                    return;
                }
                //イベントをタッチしてスキル範囲内の場合
                if (event) {
                    if ($gamePlayer.inRange($gamePlayer.attackItem().object(), event, 
                                            $gamePlayer.x, $gamePlayer.y, d)) {
                        $gamePlayer.startAttack();
                        return;
                    } else {
                        if (i === 1) return;
                    }
                }
            }
        }
        //デバッグ　キャラの上で右クリックで情報表示
        if (TouchInput.isCancelled()) {
            var x = $gameMap.canvasToMapX(TouchInput.x);
            var y = $gameMap.canvasToMapY(TouchInput.y);
            var events = $gameMap.eventsXy(x, y, 1);
            if (events.length) console.log(events[0]);
        }
        _Scene_Map_processMapTouch.apply(this, arguments);
    };
    
    var _Scene_Map_update = Scene_Map.prototype.update;
    Scene_Map.prototype.update = function() {
        var c = this._count;
        $gameSystem.updateCanAction();
        _Scene_Map_update.apply(this, arguments);
        this.updateActions();
        this.updateDisplay();
        if (c % 2 === 0) this.updateSprites();
        this.updateDebug();
        this.updateD();
        this._count++;
        
        if (this._flag === 33 && !$gameSystem.isActionPlaying()) {
            this._forceCount = (this._forceCount || 0) + 1;
            if (this._forceCount > 120) this._flag = 41, this._forceCount = 0;
        }
        
        var info = [$gameMap.displayX(), $gameMap.displayY()].toString();
        if (!this._lastPlayerXyInfo || this._lastPlayerXyInfo !== info) {
            this._lastPlayerXyInfo = info;
            //一歩動くごとの処理
        }
        
        if ($gameSystem.inMenu() &&
            Input.isPressed('A') && Input.isPressed('D') &&
            Input.isPressed('left') && Input.isPressed('right') && Input.isPressed('up') &&
            Input.isTriggered('cancel')) {
            $gameSwitches.setValue(40, true);
        }
        
        if ($gameSystem._animationPlayingCount >= 0) $gameSystem._animationPlayingCount++;
    };
    
    //行動予約の消化
    Scene_Map.prototype.updateActions = function() {
        if ($gameSystem.isBusy() || $gameSystem.isActionPlaying() || $gameSystem.isMoving()) return;
        var action = this._reservedActions[0];
        if (action) {
            action[0].startAction(action[1]);
            action[0]._useItem = action[2] || null;
            action[0]._footId = action[3] || 0;
            action[0]._onlyEffect = !!action[4];
            this._reservedActions.shift();
        }
    };
    //行動予約
    Scene_Map.prototype.reserveAction = function(character, action, use, footId, onlyEffect) {
        this._reservedActions.push([character, action, use, footId, onlyEffect]);
    };
    
    //進行
    Scene_Map.prototype.updateD = function() { 
        if (--this._DWaitCount > 0 || !$gameSystem.canMove()) {
            this._free = false;
            return;
        }
        if (this._lastActing === undefined) this._lastActing = -1;
        
        if (!this._flag) { //初期ウェイト・処理
            this._DWaitCount = 10;
            $gameSystem.bornEncount(3);
            this._flag = 1;
        }
        
        if (this._flag >= 1 && this._flag < 11) { //ターンイベント待ち
            if (this._flag === 1) {　//ターンによるイベなど
                if ($gameVariables.value(28) && $gamePlayer._D.hp > 0 &&
                    $gameSystem.isSaveOk()) {
                        //オートセーブ
                    var info = [$gameSystem.booksRate(), $gamePlayer._D._level, Math.floor(NWS()._turn / 100)].toString();
                    if (!this._lastInfoForAutoSave) this._lastInfoForAutoSave = info;
                    if (this._lastInfoForAutoSave !== info) {
                        this._lastInfoForAutoSave = info;
                            Torigoya.SaveCommand.runCommandSave(null, DataManager.lastAccessedSavefileId());
                    }
                }
                //エンカウント
                if (NWS()._turn > 0 && !$gameSystem.inRoom()) {
                    if (!Math.randomInt(2)) $gameSystem.bornEncount(1);
                }
                this._flag = 2;
            }
            if (this._flag === 2) {　//メッセージ待ち
                if ($gameSystem.canMove()) this._flag = 11;
                else this._DWaitCount = 3;
            }
        }
        
        if (this._flag >= 11 && this._flag < 21) { //プレイヤー入力待ち
            if (this._flag === 11) {
                this._acting = $gamePlayer;
                if (this._acting._D.canMove()) {
                    if (this._acting._DCount <= 0) this._acting.setDCount();
                } else {
                    this._DWaitCount = 30; //一瞬で回復するのを防ぎたい
                    NWS()._combo = 0; //コンボリセット
                    this._lastActing = 0;
                    this._free = true;
                    this._flag = 12;
                    return;
                }
                NWS()._combo = 0; //コンボリセット
                this._lastActing = 0;
                this._free = true;
                $gamePlayer._hitAttack = false;
                this._flag = 12;
            }
            if (this._flag === 12) { //行動後処理・メッセージ表示
                if (this._acting._DCount <= 0) {
                    if ($gamePlayer._hitAttack) {
                        //武器耐久値減少
                        if (NWS()._loseUseable) $gamePlayer.loseUseable();
                        //武器情報入手
                        if ($gamePlayer._gotDetails.length) {
                            $gameSwitches.setValue(35, true);
                        }
                    }
                    this._flag = 13;
                } else {
                    this._free = true;
                }
            }
            if (this._flag === 13) {
                if (!$gameSwitches.value(35)) {
                    if ($gamePlayer._hitAttack && !$gamePlayer.attackItem().object().meta.noSp) {
                        //SP増加
                        if ($gameVariables.value(12) >= 1) {
                            var a = $gamePlayer._sp < 100;
                            var speed = [9, 8, 7, 6][($gameVariables.value(12) - 1).clamp(0, 3)]
                            $gamePlayer._sp = ($gamePlayer._sp + 100 / speed).clamp(0, 100);
                            if (a && $gamePlayer._sp >= 100) {
                                $gameSystem.setDisplaySe('flash');
                                var text = ['必殺奥義の準備が完了した！', 'You are now able to use a special move!',
                                            '필살오의의 준비가 끝났다!', '必殺奧義已準備完畢！', '必杀奥义已准备完毕！'][_lg()];
                                $gameSystem.display(text);
                            }
                        }
                    }
                    //プレイヤーターン経過処理
                    this._acting._D.onAllActionsEnd();
                    $gameSystem.popResult(this._acting, true);
                    this._flag = 21;
                } else {
                    this._free = false;
                }
            }
        }
        
        if (this._flag >= 21 && this._flag < 31) { //プレイヤーアクション待ち
            if (!$gameSystem.isDisplayWaiting()) this._flag = 31;
        }
        
        if (this._flag >= 31 && this._flag < 41) { //敵アクション待ち
            if (this._flag === 31) { //行動順をまず決める
                this._actionOrder = $gameSystem.getActionOrder();
                NWS()._combo = -1; //敵の場合はコンボなし
                this._flag = 32;
            }
            if (this._flag === 32) { //順番にDCountを与え行動させる
                for (;;) {
                    if (this._actionOrder.length) {
                        var acting = this._actionOrder[0];
                        this._acting = acting;
                        if (acting._pageIndex >= 0 && !acting._D.isDead() && acting._D.canMove()) {
                            if (this._lastActing !== acting._eventId) {
                                if (acting.turnActionNum() <= 0) {
                                    var den = [2, 3, 4][-acting.turnActionNum()];
                                    if (!acting._actionNumCountStartTurn) acting._actionNumCountStartTurn = NWS()._turn;
                                    if ((NWS()._turn - acting._actionNumCountStartTurn) % den === den - 1) {
                                        acting._DActionCount += 1;
                                        acting._DAttackCount += 1;
                                    }
                                } else {
                                    acting._actionNumCountStartTurn = null;
                                    acting._DActionCount += acting.turnActionNum();
                                    acting._DAttackCount += acting.turnAttackNum();
                                }
                            }
                            if (acting._DActionCount > 0) {
                                acting.setDCount();
                                acting._decidedAction = false;
                                acting.decideAction();
                                this._lastActing = acting._eventId;
                                var playAction = acting._action && acting._action.item();
                                if (--acting._DActionCount <= 0 || (playAction && --acting._DAttackCount <= 0)) {
                                    acting._DActionCount = acting._DAttackCount = 0;
                                    this._actionOrder.shift();
                                }
                            } else {
                                acting._DActionCount = acting._DAttackCount = 0;
                                this._actionOrder.shift();
                            }
                        } else {
                            this._actionOrder.shift();
                        }
                    } else {
                        this._actionOrder = $gameSystem.getActionOrder();
                        this._flag = 33;
                    }
                    if (this._flag !== 32) break;
                }
            }
            if (this._flag === 33) { //行動待ち
                if ($gameSystem.canMove() &&
                    this._actionOrder.every(function(event) {
                        return event._DCount <= 0;
                    }))
                { //全員行動終了
                    this._acting = null;
                    this._flag = 41;
                }
            }
        }
        
        if (this._flag >= 41 && this._flag < 51) { //ターン後イベント待ち
            if (this._flag === 41) { //ターン後処理・メッセージ表示
                this._actionOrder = $gameSystem.getActionOrder();
                this._actionOrder.forEach(function(event) {
                    event._DCount = 0;
                });
                [$gamePlayer].concat(this._actionOrder).forEach(function(event, id) {
                    if (id !== 0) {
                        event._D.onAllActionsEnd();
                        $gameSystem.popResult(event, true);
                    }
                    event._D.onTurnEnd();
                    $gameSystem.popResult(event, true);
                    event._targets = [];
                }, this);
                this._actionOrder = [];
                this._flag = 42;
            }
            if (this._flag === 42) { //待ち
                if ($gameSystem.canMove()) this._flag = 43;
                else this._DWaitCount = 3;
            }
            if (this._flag === 43) { //経験値とお金獲得
                $gamePlayer.gainExpAndGold();
                this._flag = 44;
            }
            if (this._flag === 44) { //待ち
                if ($gameSystem.canMove()) {
                    NWS()._turn++, this._flag = 1;
                    if ($dataMap.meta.SBI) {
                        var scorePlus = 10 + Math.floor(NWS()._turn / 10);
                        $gameVariables.setValue(30, $gameVariables.value(30) + scorePlus);
                    }
                } else {
                    this._DWaitCount = 3;
                }
            }
        }
    };
      
    
    Scene_Map.prototype.updateDisplay = function() {
        if ($gameSystem.isBusy() || $gameSystem.inMenu() || $gameSystem.isMoving(true)) return;
        if (this._displayWaitAnime && $gameSystem.isAnimationPlaying())
            return this._displayCount = $gameSystem.displayBaseWait();
        this._displayWaitAnime = false;
        this._displayCount--;
        if (this._displayCount > 0) return;
        if (this._displayOrder.length) {
            var order = this._displayOrder[0], target = order[1];
            if (order[0] === 'SE') { //SEを鳴らすだけの場合
                $gameSystem.playDisplaySe(order[1]);
            } else { //テキストを表示
                $gameSystem._popMessage.push(order[0]);
                if (target) {
                    if (order[2]) target.requestAnimation(order[2]);
                    if (order[3]) {
                        if (order[3][0] === 'hp') target.popupDamage(Math.ceil(order[3][1]), order[3][2] || false);
                        if (order[3][0] === 'mp') target.popupMpDamage(Math.ceil(order[3][1]), order[3][2] || false);
                    }
                    if (order[4]) target.setMotion(order[4]);
                }
//                this._displayCount = Number(order[5]);
//                if (!this._displayCount && this._displayCount !== 0) this._displayCount = 30;
                this._displayCount = Number(order[5]) || $gameSystem.displayBaseWait();
                if (order[5] === 'animation') this._displayWaitAnime = true;
            }
            this._displayOrder.shift();
        }
    };
    
    Game_System.prototype.displayBaseWait = function() {
        return $gameVariables.value(29) ? 15 : 30;
    };
    
    Game_System.prototype.playDisplaySe = function(type) { //SEを鳴らす
        if (type === 'miss')            AudioManager.playSe({name:'01_Miss', volume:200, pitch:120, pan:0});
        else if (type === 'throw')      AudioManager.playSe({name:'Wind4', volume:90, pitch:100, pan:0});
        else if (type === 'equip')      AudioManager.playSe({name:'Key', volume:120, pitch:140, pan:0});
        else if (type === 'warning')    AudioManager.playSe({name:'01_Alarm', volume:200, pitch:100, pan:0});
        else if (type === 'break')      AudioManager.playSe({name:'Break', volume:90, pitch:100, pan:0});
        else if (type === 'piki')       AudioManager.playSe({name:'Break', volume:80, pitch:150, pan:0});
        else if (type === 'crash')      AudioManager.playSe({name:'Crash', volume:70, pitch:120, pan:0});
        else if (type === 'item')       AudioManager.playSe({name:'01_Item', volume:200, pitch:100, pan:0});
        else if (type === 'gold')       AudioManager.playSe({name:'Coin', volume:90, pitch:100, pan:0});
        else if (type === 'exp')        AudioManager.playSe({name:'Ice8', volume:90, pitch:150, pan:0});
        else if (type === 'itemDrop')   AudioManager.playSe({name:'01_Item', volume:200, pitch:100, pan:0});
        else if (type === 'flash')      AudioManager.playSe({name:'Flash2', volume:90, pitch:150, pan:0});
        else if (type === 'attack')     AudioManager.playSe({name:'Attack1', volume:100, pitch:130, pan:0});
        else if (type === 'up')         AudioManager.playSe({name:'Heal3', volume:90, pitch:150, pan:0});
        else if (type === 'down')       AudioManager.playSe({name:'Down1', volume:90, pitch:100, pan:0});
        else if (type === 'chest')      AudioManager.playSe({name:'Chest2', volume:90, pitch:100, pan:0});
        else if (type === 'bow')        AudioManager.playSe({name:'Bow1', volume:90, pitch:100, pan:0});
        else if (type === 'fall')       AudioManager.playSe({name:'Fall', volume:80, pitch:150, pan:0});
        else if (type === 'shop')       AudioManager.playSe({name:'Shop1', volume:90, pitch:100, pan:0});
        else if (type === 'kote')       AudioManager.playSe({name:'01_Item', volume:400, pitch:60, pan:0});
        else if (type === 'darkness')   AudioManager.playSe({name:'Darkness5', volume:80, pitch:100, pan:0});
    };
    
    Scene_Map.prototype.isFastForward = function() {
        return false;
    };
    
    Scene_Map.prototype.updateDebug = function() {
        if ($gameTemp.isPlaytest()) { //デバッグ表示
            if (!this._debugDisplay) {
                this._debugDisplay = new Sprite();
                this._debugDisplay.move(0, 96, 144, 200);
                this._debugDisplay.bitmap = new Bitmap(200, 200);
                this._debugDisplay.bitmap.fontSize = 16;
                this.addWindow(this._debugDisplay);
                this._debugCount = 0;
            }
            if (this._debugCount++ % 6 === 0 && false) {
                this._debugDisplay.bitmap.clear();
                this._debugDisplay.bitmap.drawText('flag : ' + this._flag, 0, 0, 200, 48, 'left');
                this._debugDisplay.bitmap.drawText('DCount : ' + $gamePlayer._DCount, 0, 20, 200, 48, 'left');
                this._debugDisplay.bitmap.drawText('turn : ' + NWS()._turn, 0, 40, 200, 48, 'left');
                this._debugDisplay.bitmap.drawText('fast : ' + this.isFastForward(), 0, 60, 200, 48, 'left');
                this._debugDisplay.bitmap.drawText('reserve : ' + this._reservedActions.length, 0, 80, 200, 48, 'left');
                this._debugDisplay.bitmap.drawText('display : ' + this._displayOrder.length, 0, 100, 100, 48, 'left');
                this._debugDisplay.bitmap.drawText('usingChild : ' + $gamePlayer._usingChildSkill, 0, 120, 200, 48, 'left');
                this._debugDisplay.bitmap.drawText('playing : ' + $gameSystem.isAnimationPlaying(), 0, 140, 200, 48, 'left');
            }
        }
    };
    
    //薬草
    Scene_Map.prototype.onHeal = function() {
        if (NWS()._heal <= 0) {
            $gameSystem.setDisplaySe('miss');
            var text = ['%1は\\i[261]薬草を持っていない！', '%1 doesn\'t have any \\i[261]herbs!',
                        '%1한테는 \\i[261]약초가 없다!', '%1沒有\\i[261]藥草！', '%1没有\\i[261]药草！'][_lg()];
            $gameSystem.display(text.format($gamePlayer._D.name()));
        } else {
            $gamePlayer._DCount++;
            $gamePlayer.useItem($gameSystem.newItem(2));
            NWS()._heal--;
        }
    };
    //早送り
    Scene_Map.prototype.onSkip = function() {
        if ($gamePlayer.canInput()) $gamePlayer._DCount--;
    };
    //武器を拾う
    Scene_Map.prototype.onGetWeapon = function() {
        var x1 = $gamePlayer.x, y1 = $gamePlayer.y;
        var x2 = $gameMap.roundXWithDirection(x1, $gamePlayer._direction);
        var y2 = $gameMap.roundYWithDirection(y1, $gamePlayer._direction);
        for (var i = 0; i < 3; i++) {
            if (NWS()._getSpecial && i === 1) continue;
            var x = i === 1 ? $gamePlayer.x :
                    $gameMap.roundXWithDirection($gamePlayer.x, $gamePlayer._direction);
            var y = i === 1 ? $gamePlayer.y :
                    $gameMap.roundYWithDirection($gamePlayer.y, $gamePlayer._direction);
//            if ([2, 3].contains($gameMap.regionId(x, y))) continue; //リージョン2, 3の床では拾えない
            if ($gameMap.eventsXy(x, y).some(function(event) {
                    return event && event.isTriggerIn([0, 1, 2]) && 
                        (event._priorityType === 0 || event.isNormalPriority());
                }))
            {
                NWS()._gettingWeapon = true;
                $gamePlayer.startMapEvent(x, y, [0, 1, 2], true);
                if (i !== 0) {
                    NWS()._gettingWeapon = true;
                    $gamePlayer.startMapEvent(x, y, [0, 1, 2], false);
                }
            }
        }
    };
    //武器チェンジ
    Scene_Map.prototype.onChangeWeapon = function() {
        if ($gamePlayer._D.metaState('cannotChangeWeapon')) {
            $gameSystem.setDisplaySe('miss');
            var text = ['%1は武器を変えることができない！', '%1 can\'t change weapons!',
                        '%1는 무기를 변경할 수가 없다!', '%1沒辦法更換武器！', '%1没办法更换武器！'][_lg()];
            $gameSystem.display(text.format($gamePlayer._D.name()));
            return;
        }
        NWS()._choiceCondition = [];
        this.startWeaponList(1);
    };
    //攻撃
    Scene_Map.prototype.onAttack = function() {
        if (NWS()._canAction && $gamePlayer._DCount > 0 && !$gameSwitches.value(5)) {
            if (!$gamePlayer.areTriggerEventsInFront()) {
                $gamePlayer.startAttack();
            } else {
                var x = $gameMap.roundXWithDirection($gamePlayer.x, $gamePlayer._direction);
                var y = $gameMap.roundYWithDirection($gamePlayer.y, $gamePlayer._direction);
                $gamePlayer.startMapEvent(x, y, [0], true);
            }
        }
    };
    //空を飛ぶ
    Scene_Map.prototype.onFly = function() {
        $gameSwitches.setValue(24, true);
    };
    
    //ボタンの上にカーソルがある
    Scene_Map.prototype.isTouchedInsideButton = function() {
        var x = TouchInput.x, y = TouchInput.y;
        var objs = [].concat(this._buttons);
        objs.push(this._statusWindow);
        objs.push(this._statesInfoWindow);
        return objs.some(function(obj) {
            if (!obj) return false;
            var b = obj;
            return x >= b.x && y >= b.y && x < b.x + b.width && y < b.y + b.height;
        })
    };
    //武器を探した時はイベントはプレイヤーのほうを向かない
    Game_Event.prototype.lock = function() {
        if (!this._locked) {
            this._prelockDirection = this.direction();
            if (!NWS()._gettingWeapon) this.turnTowardPlayer();
            this._locked = true;
        }
    };
    //イベントID大きい方を優先して発動
    Game_Player.prototype.startMapEvent = function(x, y, triggers, normal) {
        if (!$gameMap.isEventRunning() && !$gameSystem.isFlying()) {
            var events = $gameMap.eventsXy(x, y, 1).filter(function(event) {
                return (event.isTriggerIn(triggers) && event.isNormalPriority() === normal);
            });
            if (events.length) {
                for (var i = events.length - 1; i >= 0; i--) {
                    if (events[i] &&
                        !($gameSystem.inRoom() && events[i].event().meta.house) && //室内で家本体は無視
                        !($gameSystem.inRoom() && $gameMap.regionId(x, y) !== 16 && !events[i].event().meta.canByHouse) &&
                         //室内で外のイベントは呼べない 壁の家具は例外
                        !(NWS()._gettingWeapon && !events[i].event().meta.weapon)
                    ) {
                        if (!this._testTriggerEvents) events[i].start();
                        return events[i];
                    }
                }
            }
            NWS()._gettingWeapon = false;
            return null;
        }
    };
    
    var _Game_Map_eventsXy = Game_Map.prototype.eventsXy;
    Game_Map.prototype.eventsXy = function(x, y, sort) {
        var events = _Game_Map_eventsXy.apply(this, arguments);
        if (!sort) return events;
        return events.sort(function(a, b) {
            if (a.screenZ() !== b.screenZ()) return a.screenZ() - b.screenZ();
            if (a._transparent !== b._transparent) return a._transparent ? -1 : 1;
            var sp = function(ch) {
                return SceneManager._scene._spriteset._characterSprites.filter(function(sprite, index) {
                    return sprite._character instanceof Game_Event && sprite._character._eventId === ch._eventId;
                }, this)[0];
            }
            if (!sp(a) || !sp(b)) return !sp(a) ? -1 : 1;
            return sp(a).spriteId - sp(b).spriteId;
        });
    };
    
    //家の外と中のため互いに干渉しない状態かどうか
    Game_Map.prototype.roomStateDiffer = function(x, y, x2, y2) {
        var rId  = $gameMap.regionId(x, y);
        var rId2 = $gameMap.regionId(x2, y2);
        var house = $gameMap.eventsXy(x, y).some(function(event) {return event.event() && event.event().meta.house});
        var house2 =$gameMap.eventsXy(x2, y2).some(function(event) {return event.event() &&event.event().meta.house});
        return ((house !== house2 && !(rId === 16 && rId2 === 16)) || 
            ($gameSystem.inRoom() && (rId === 16 && rId2 !== 16 || rId !== 16 && rId2 === 16)));
    };
    
    Game_Event.prototype.meetsConditions = function(page) {
        var c = page.conditions;
        if (c.switch1Valid && !$gameSwitches.value(c.switch1Id)) return false;
        if (c.switch2Valid && !$gameSwitches.value(c.switch2Id)) return false;
        if (c.variableValid && $gameVariables.value(c.variableId) < c.variableValue) return false;
    
        if (c.selfSwitchValid) {
            var key = [this._mapId, this._eventId, c.selfSwitchCh];
            if ($gameSelfSwitches.value(key) !== true) {
                key = c.selfSwitchCh === 'A' ? this.selfSwitchCode() : key;
                if ($gameSelfSwitches.value(key) !== true) return false;
            }
        }
    
        if (c.itemValid && !$gameParty.hasItem($dataItems[c.itemId])) return false;
        if (c.actorValid && !$gameParty.members().contains($gameActors.actor(c.actorId))) return false;
        return true;
    };

    
    //-----------------------------------------------------------------------------
    // Sprite関係
    //-----------------------------------------------------------------------------
    
    
    //ステート・HPゲージ表示・軽量化
    var _Sprite_Character_update = Sprite_Character.prototype.update;
    Sprite_Character.prototype.update = function() {
        if (!this._character || (!this._character.isPlayer() && this._character.needNotSprite())) {
            this.opacity = 0;
            return this.updatePosition();
        }
        this._firstUpdateFinished = true;
        var a = (this._character._important || this._character._updateFrequently ||
                 this._character._moveRouteForcing || this._character._moveType === 3) ? 2 :
                this._character.isCharacter() ? (!this._character.isStopping() ? 3 : 6) :
                this._character._stepAnime ? 6 : 12;
        this._updateCount = this._updateCount || 1;
        if (!this._character.isPlayer() && !this._character.isItem() && this._updateCount++ % a !== a - 1) return this.updatePosition();
        
        if (this._character.isCharacter() && SceneManager._scene._spriteset) {
            if (!this._stateSprite && this._character._D._states.length) {
                Sprite_Actor.prototype.createStateSprite.call(this);
                this._stateSprite.setup(this._character._D);
                this._stateSprite._character = this._character;
            }
            if (!this._hpGaugeSprite && !this._character.isPlayer() && this._character._needRefreshHpGauge) {
                this._hpGaugeSprite = new Sprite_CharacterHpGauge(this._character);
                SceneManager._scene._spriteset._baseSprite.addChild(this._hpGaugeSprite);
            }
        }
        if (this._character.isCharacter()) {
            this.updateWeapon();
            this.updateWeaponFire();
        }
        _Sprite_Character_update.apply(this, arguments);
        
        //武器投げ用　回転
        if (this._character._rotateSprite) {
            if (this.rotation === 0) this._character.playSe('Wind4', _rand(70, 80), _rand(120, 140));
            this._character._angle = (this._character._angle + 360 / 15) % 360;
        }
    };
    var _Sprite_StateOverlay_initialize = Sprite_StateOverlay.prototype.initialize;
    Sprite_StateOverlay.prototype.initialize = function() {
        _Sprite_StateOverlay_initialize.apply(this, arguments);
        this.scale.x = this.scale.y = 48 / 64;
    };
    
    var _Sprite_StateOverlay_update = Sprite_StateOverlay.prototype.update;
    Sprite_StateOverlay.prototype.update = function() {
        if ($gameSystem.inMenu() || this._character.needNotUpdate()) return;
        if (this._battler.isDead()) return this.opacity = 0;
        _Sprite_StateOverlay_update.apply(this, arguments);
    };
    var _Sprite_Character_updateFrame = Sprite_Character.prototype.updateFrame;
    Sprite_Character.prototype.updateFrame = function() {
        var info = [this._tileId, this._characterName, this._characterIndex,
                    this.characterPatternX(), this.characterPatternY(), this.bitmap.isReady()].toString();
        if (this._lastFrameInfo && this._lastFrameInfo === info) return;
        this._lastFrameInfo = info;
        _Sprite_Character_updateFrame.apply(this, arguments);
    };
    
    //セーブファイル改変
    var _DataManager_makeSavefileInfo = DataManager.makeSavefileInfo;
    DataManager.makeSavefileInfo = function() {
        var info = _DataManager_makeSavefileInfo.apply(this, arguments);
        info.version    = $gameSystem._version;
        info.booksRate  = $gameSystem.booksRate();
        info.level      = $gamePlayer._D._level;
        info.mapName    = $dataMap.displayName;
        info.tr = 0; for (var i = 0; i < 4; i++) if ($gameSwitches.value(41 + i)) info.tr++;
        return info;
    };
    Window_SavefileList.prototype.drawContents = function(info, rect, valid) {
        var bottom = rect.y + rect.height;
        var x, y, w, h;
        x = rect.x + 106, y = rect.y, w = rect.width - 106 - 96, h = 26;
        var title = $gameSystem.title();
        this.drawText(title, x, y, w, 'center');
        w = 96, x = rect.width - w - 2, y += 2;
        info.version = info.version || '0.10';
        this.contents.fillRect(x, y, w, h, this.contents.outlineColor);
        this.drawText('ver%1'.format(info.version), x, y, w, 'center');
        x = rect.x, y += 28, w = rect.width;
        this.contents.fontSize -= 4;
        var text = '%1 Lv.%2 / %3 / %4 / %5'.format(
            Game_Actor.prototype.name.call({_actorId : 1}), info.level,
            $gameMap.displayName(info.mapName),
            '%2 %1％'.format(info.booksRate, [['武器図鑑', 'Weapons Gallery', '도감', '圖鑑', '图鉴'][_lg()]]),
            info.playtime
        );
        this.drawText(text, x, y, w, 'center');
        w = 24, x = rect.width - w, y += 4;
        for (var i = 0; i < info.tr; i++) {
            this.drawIcon(90, x, y, w);
            x -= w;
        }
        this.contents.fontSize += 4;
    };
    
    //武器表示・残像
    Sprite_Character.prototype.updateWeapon = function() {
        this._bushDepth = 1;
        if (this._lowerBody) this._lowerBody.opacity = 255;
        
        this._weaponId = this._character.attackItem().object().id;
        if (this._weaponId === 1 && !this._weaponSprite && !this._character.isPlayer()) return;
        
        var info = [this._weaponId, this._character.attackItem().imageName(), $gameSystem.isFlying()].toString();
        if (!this._lastInfo || this._lastInfo !== info) {
            this._lastInfo = info;
            if (!this._weaponSprite) {
                this._weaponSprite = new Sprite_Base();
                this.addChild(this._weaponSprite);
            }
            this._weaponSprite.bitmap = null;
            if (this._character.isPlayer()) {
                this._character._characterIndex = 
                    $gameSystem.isFlying() ? 3 :
                    this._weaponId === 1 ? 0 :
                    (Number(this._character.attackItem().object().meta.characterIndex) || 1);
            }
            if (this._weaponId === 1) return;
            this._weaponSprite.bitmap = ImageManager.loadBitmap('img/weapons/', this._character.attackItem().imageName());
            this._weaponSprite.bitmap.addLoadListener(function(){
                
                var btOk, tpOk, bottomY = this._weaponSprite.bitmap.height - 1, topY = 0;
                for (var i = 0; i < this._weaponSprite.bitmap.height / 2 && !btOk && !tpOk; i++) {
                    var x = Math.round(this._weaponSprite.bitmap.width / 2);
                    if (!btOk && this._weaponSprite.bitmap.getPixel(x, bottomY) !== '#000000') btOk = true;
                    if (!btOk) bottomY--;
                    if (!tpOk && this._weaponSprite.bitmap.getPixel(x, topY) !== '#000000') tpOk = true;
                    if (!tpOk) topY++;
                }
                this._weaponSprite._bottomY = bottomY - 2;
                this._weaponSprite._topY = topY;
                
                var sdOk, sideX = this._weaponSprite.bitmap.width - 1;
                for (var i = 0; i < this._weaponSprite.bitmap.width / 2 && !sdOk; i++) {
                    var y = Math.round(this._weaponSprite.bitmap.height * 2 / 3);
                    if (!sdOk && this._weaponSprite.bitmap.getPixel(sideX, y) !== '#000000') sdOk = true;
                    if (!sdOk) sideX--;
                }
                this._weaponSprite._sideX = sideX;
                
                if (this._character.isPlayer()) this._character._wepBmpWidth = this._weaponSprite.bitmap.width;
            }.bind(this));
        }
        if (!this._weaponSprite.bitmap || !this._weaponSprite.bitmap.isReady()) return;
        if (!this.setWeaponZ) this.setWeaponZ = function(front) {
            if (!this._weaponSprite || !this._upperBody) return;
            this.removeChild(this._weaponSprite);
            var residualSprite = this._weaponSprite._residualSprite;
            if (residualSprite) this.removeChild(residualSprite);
            this.addChildAt(this._weaponSprite, this.getChildIndex(this._upperBody) + (front ? 2 : 0));
            if (residualSprite) this.addChildAt(residualSprite, this.getChildIndex(this._weaponSprite));
            var targetOpacity = (front && this._weaponSprite.bitmap.height > 96) ? 255 : 255;
            if (NWS()._isShift) targetOpacity *= 0.33;
            if (this._character._D._dead && this._character._characterIndex === 4) targetOpacity *= 0;
            this._weaponSprite.opacity = (targetOpacity + this._weaponSprite.opacity) / 2;
        }
        var x, y, angle;
        var anime = this._character._weaponAnime || 0, pat = this._character._pattern, rev = false;
        if (anime === 6) {
            this._weaponSprite.anchor.x = 
                [4, 6].contains(this._character._direction) ?
                (this._weaponSprite._sideX / this._weaponSprite.bitmap.width + 0.5) / 2 : 0.5;
            this._weaponSprite.anchor.y = 0.667;
        } else {
            this._weaponSprite.anchor.x = 0.5;
            this._weaponSprite.anchor.y = this._weaponSprite._bottomY / this._weaponSprite.bitmap.height;
            if (this._character._wepDisplayType === 1) 
                this._weaponSprite.anchor.y += 68 / this._weaponSprite.bitmap.height;
        }
        if (this._character._direction === 2) {
            if (anime === 0) 
                this.setWeaponZ(0), x = -12, y = [-18, -17, -16, -17][pat], angle = [-13, -16, -18, -16][pat];
            else if (anime === 1) 
                this.setWeaponZ(0), x = -11, y = -17, angle = 10;
            else if (anime === 2) 
                this.setWeaponZ(1), x = -14, y = -16, angle = -50;
            else if (anime === 3) 
                this.setWeaponZ(1), x = -13, y = -16, angle = -110;
            else if (anime === 4) 
                this.setWeaponZ(1), x = -12, y = -12, angle = -170;
            else if (anime === 5) 
                this.setWeaponZ(1), x = -12, y = -12, angle = -230;
            else if (anime === 6)
                this.setWeaponZ(0), x = 0, y = -8 + [0, -1, -2, -1][pat], angle = 0;
        } else if (this._character._direction === 4) {
            if (anime === 0) 
                this.setWeaponZ(0), x = -4, y = [-18, -17, -16, -17][pat], angle = [-11, -14, -16, -14][pat];
            else if (anime === 1) 
                this.setWeaponZ(0), x = 3, y = -15, angle = 60;
            else if (anime === 2) 
                this.setWeaponZ(0), x = -4, y = -16, angle = 10;
            else if (anime === 3) 
                this.setWeaponZ(0), x = -5, y = -14, angle = -40;
            else if (anime === 4) 
                this.setWeaponZ(1), x = -6, y = -12, angle = -90;
            else if (anime === 5) 
                this.setWeaponZ(1), x = -6, y = -12, angle = -140;
            else if (anime === 6)
                this.setWeaponZ(0), x = 0, y = -8 + [0, -1, -2, -1][pat], angle = 100;
        } else if (this._character._direction === 6) {
            rev = true;
            if (anime === 0) 
                this.setWeaponZ(1), x = 4, y = [-18, -17, -16, -17][pat], angle = [11, 14, 16, 14][pat];
            else if (anime === 1) 
                this.setWeaponZ(1), x = -3, y = -15, angle = -60;
            else if (anime === 2) 
                this.setWeaponZ(1), x = 4, y = -16, angle = -10;
            else if (anime === 3) 
                this.setWeaponZ(1), x = 5, y = -14, angle = 40;
            else if (anime === 4) 
                this.setWeaponZ(1), x = 6, y = -12, angle = 90;
            else if (anime === 5) 
                this.setWeaponZ(1), x = 6, y = -12, angle = 140;
            else if (anime === 6)
                this.setWeaponZ(0), x = 0, y = -8 + [0, -1, -2, -1][pat], angle = -100;
        } else if (this._character._direction === 8) {
            if (anime === 0) 
                this.setWeaponZ(1), x = 12, y = [-18, -17, -16, -17][pat], angle = [13, 16, 18, 16][pat], 
                rev = true;
            else if (anime === 1) 
                this.setWeaponZ(1), x = 11, y = -14, angle = 130;
            else if (anime === 2) 
                this.setWeaponZ(0), x = 14, y = -16, angle = 70;
            else if (anime === 3) 
                this.setWeaponZ(0), x = 13, y = -16, angle = 10;
            else if (anime === 4) 
                this.setWeaponZ(0), x = 12, y = -20, angle = -50;
            else if (anime === 5) 
                this.setWeaponZ(0), x = 12, y = -20, angle = -110;
            else if (anime === 6)
                this.setWeaponZ(0), x = 0, y = -8 + [0, -1, -2, -1][pat], angle = 180;
        }
        this._weaponSprite.x = x;
        this._weaponSprite.y = y + 3;
        this._weaponSprite.rotation = angle * Math.PI / 180;
        
        var meta = this._character.attackItem().object().meta;
        this._weaponSprite.scale.x = meta.asymmetry && rev ? -1 : 1;
        if (anime === 6) this._weaponSprite.scale.x = rev ? 1 : -1
        if (meta.reverse) this._weaponSprite.scale.x *= -1;
    };
    //武器炎表示
    Sprite_Character.prototype.updateWeaponFire = function() {
        if (!this._character._weaponFire && !this._weaponFireSprite) return;
        if (this._weaponFire === undefined || this._weaponFire !== this._character._weaponFire) {
            this._weaponFire = !!this._character._weaponFire;
            if (!this._weaponFireSprite) {
                this._weaponFireSprite = new Sprite(ImageManager.loadBitmap('img/weapons/', '_fire'));
                this._weaponFireSprite.opacity = 0;
                this._weaponFireSprite.anchor.x = 0.5, this._weaponFireSprite.anchor.y = 1;
                this._weaponFireSprite.blendMode = 1;
                this.addChild(this._weaponFireSprite);
            }
        }
        if (!this._weaponFire) {
            this._weaponFireSprite.opacity = 0;
            this._character._weaponFireXy = null;
            return;
        }
        if (!this._weaponFireSprite.bitmap.isReady()) return;
        this._weaponFireSprite._animeCount = ((this._weaponFireSprite._animeCount || 0) + 1) % 42;
        var pattern = Math.floor(this._weaponFireSprite._animeCount / 14);
        var bitmap = this._weaponFireSprite.bitmap;
        this._weaponFireSprite.setFrame(pattern * bitmap.width / 3, 0, bitmap.width / 3, bitmap.height);
        
        if (!this._weaponSprite || !this._weaponSprite.bitmap || !this._weaponSprite.bitmap.isReady()) return;
        this.removeChild(this._weaponFireSprite);
        this.addChildAt(this._weaponFireSprite, this.getChildIndex(this._weaponSprite) + 1);
        this._weaponFireSprite.opacity = 255;
        var spr = this._weaponSprite, bmp = this._weaponSprite.bitmap;
        var rot = (spr.rotation * 180 / Math.PI + 360 * 3) % 360;
        var h = Math.min((spr.anchor.y - 0.1) * bmp.height - spr._topY - 12, 48 * 3.5);
        var x = spr.x + (rot <= 180 ? 1 : -1) * 
            h * Math.abs(Math.sin(spr.rotation));
        var y = spr.y + (rot >= 90 && rot <= 270 ? 1 : -1) * 
            h * Math.abs(Math.cos(spr.rotation));
        var scale = 1 + Math.max((Math.sqrt(Math.pow(x, 2) + Math.pow(y, 2)) - 48) / 144, 0)
        this._weaponFireSprite.x = x, this._weaponFireSprite.y = y;
        this._weaponFireSprite.scale.x = this._weaponFireSprite.scale.y = scale;
        this._character._weaponFireXy = [x * 0.66, y * 0.66];
    };
    
    var _Spriteset_Map_update = Spriteset_Map.prototype.update;
    Spriteset_Map.prototype.update = function() {
        _Spriteset_Map_update.apply(this, arguments);
        if (!this._outOfRoom) {
            var color = 'rgba(50,45,40,1)';
            this._outOfRoom = new Sprite(new Bitmap($gameMap.width() * 48, $gameMap.height() * 48));
            for (var x = 0; x < $gameMap.width(); x++) for (var y = 0; y < $gameMap.height(); y++) {
                if ($gameMap.regionId(x, y) !== 16) this._outOfRoom.bitmap.fillRect(x * 48, y * 48, 48, 48, color);
            }
            this._outOfRoom.opacity = 0;
            this._outOfRoom.z = 0.1;
            this._tilemap.addChild(this._outOfRoom);
        }
        this._outOfRoom.x = -this._tilemap.origin.x;
        this._outOfRoom.y = -this._tilemap.origin.y;
        this._outOfRoom.opacity += 255 / 20 * ($gameSystem.inRoom() ? 1 : -1);
    };
    
    //-----------------------------------------------------------------------------
    // Sprite_CharacterHpGauge
    //

    function Sprite_CharacterHpGauge() {
        this.initialize.apply(this, arguments);
    }
    Sprite_CharacterHpGauge.prototype = Object.create(Sprite.prototype);
    Sprite_CharacterHpGauge.prototype.constructor = Sprite_CharacterHpGauge;

    Sprite_CharacterHpGauge.prototype.initialize = function(character) {
        Sprite.prototype.initialize.call(this);
        this._character    = character;
        this._battler      = character._D;
        this._hpRate       = 1;
        this._targetHpRate = this._hpRate;
        this._width = 48, this._height = 8;
        this.move(0, 0, this._width, this._height);
        this.makeAllParts();
        this.anchor.x = 0.5;
        this.anchor.y = 0.5;
        this.opacity = 0;
        this._count = 0;
    };

    Sprite_CharacterHpGauge.prototype.makeAllParts = function() {
        this.bitmap = new Bitmap(this._width, this._height);
        this.bitmap.fillRect(0, 0, this.bitmap.width, this.bitmap.height, 'white');
        this.bitmap.fillRect(1, 1, this.bitmap.width - 2, this.bitmap.height - 2, 'rgba(32, 32, 64, 1)');
        
        this._changeRect = new Sprite(new Bitmap(this._width - 2, this._height - 2));
        this._changeRect.x = -this._width / 2 + 1, this._changeRect.y= -this._height / 2 + 1;
        this._changeRect.anchor.x = 0;
        this.addChild(this._changeRect);
        
        this._hpRect = new Sprite(new Bitmap(this._width - 2, this._height - 2));
        this._hpRect.x = -this._width / 2 + 1, this._hpRect.y= -this._height / 2 + 1;
        this._hpRect.anchor.x = 0;
        this._hpRect.bitmap.gradientFillRect(0, 0, this._hpRect.bitmap.width, this._hpRect.bitmap.height,
                                             'rgba(224, 128, 64, 1)', 'rgba(240, 192, 64, 1)');
        this.addChild(this._hpRect);
        
    };

    Sprite_CharacterHpGauge.prototype.update = function() {
        if (this._character.needNotUpdate() || this._character._needDeleteHpGauge || !this._character._D ||
           (!this.opacity && this._character._D.hpRate() >= 1)) return this.opacity = 0;
        Sprite.prototype.update.call(this);
        this.x = this._character.screenX();
        this.y = this._character.screenY() - (this._character._height || 48) - 4;
        if (this._character._needRefreshHpGauge) {
            this.opacity = 255, this._count = 60;
            this._character._needRefreshHpGauge = false;
            this._targetHpRate = this._battler.hpRate();
            this._changeRect.bitmap.clear();
            this._changeRect.bitmap.fillRect(0, 0, this._hpRect.bitmap.width, this._hpRect.bitmap.height,
                                             this._hpRate < this._targetHpRate ? 'aqua' : 'red');
        }
        if (this._hpRate !== this._targetHpRate) {
            this._hpRate += (this._targetHpRate - this._hpRate) / 12;
            if (Math.abs(this._targetHpRate - this._hpRate) <= 0.01) this._hpRate = this._targetHpRate;
        }
        if (this._hpRate < 1) this.opacity = 255, this._count = 60;
        else if (this._count-- <= 0) this.opacity = 0;
        
        var isHealing = this._hpRate < this._targetHpRate;
        this._changeRect.scale.x = isHealing ? this._targetHpRate : this._hpRate;
        this._hpRect.scale.x = isHealing ? this._hpRate : this._targetHpRate;
    };
    
    //その他軽量化
    Game_Map.prototype.events = function(all) {
        if (all) return this._events.filter(function(event) {
            return !!event;
        });
                                   
        var info = [$gameMap.displayX(), $gameMap.displayY()];
        if (!this._nearEvents || !this._nearEvents.length || !this._lastPlayerXyInfo ||
            this._lastPlayerXyInfo[0] !== info[0] || this._lastPlayerXyInfo[1] !== info[1]) {
            this._lastPlayerXyInfo = info;
            if (!this._periEvents || !this._periEvents.length || !this._lastPlayerXyInfo2 ||
                Math.abs(this._lastPlayerXyInfo2[0] - info[0]) > 12 ||
                Math.abs(this._lastPlayerXyInfo2[1] - info[1]) > 6)
            {
                this._lastPlayerXyInfo2 = info;
                this._periEvents = this._events.filter(function(event) {
                    return !!event && !event.needNot();
                });
            }
            this._nearEvents = this._periEvents.filter(function(event) {
                return !event.needNotUpdate();
            });
        }
        return this._nearEvents;
    };
    
    Game_Map.prototype.rejudgeEvents = function() {
        this._lastPlayerXyInfo = this._lastPlayerXyInfo2 = null;
        if (SceneManager._scene._spriteset) SceneManager._scene._spriteset.refreshChildCharacters();
    };
    
    Game_Map.prototype.setupEvents = function() {
        this._events = [];
        this._periEvents = [];
        this._nearEvents = [];
        for (var i = 0; i < $dataMap.events.length; i++) {
            if ($dataMap.events[i]) this._events[i] = new Game_Event(this._mapId, i);
        }
        this._commonEvents = this.parallelCommonEvents().map(function(commonEvent) {
            return new Game_CommonEvent(commonEvent.id);
        });
        this.refreshTileEvents();
        this.rejudgeEvents();
    };

    
    var _Spriteset_Map_createCharacters = Spriteset_Map.prototype.createCharacters;
    Spriteset_Map.prototype.createCharacters = function() {
        this._characterSprites = null;
        this._characterSprites = [];
        var frame = 0;
        var self = this;
        $gameMap.events(1).forEach(function(event) {
            setTimeout(function() {
                self._characterSprites.push(new Sprite_Character(event));
            }, frame);
            if (!$gameTemp.isPlaytest()) frame++;
        }, this);
        $gameMap.vehicles().forEach(function(vehicle) {
//            this._characterSprites.push(new Sprite_Character(vehicle));
        }, this);
        $gamePlayer.followers().reverseEach(function(follower) {
//            this._characterSprites.push(new Sprite_Character(follower));
        }, this);
        setTimeout(function() {
            self._characterSprites.push(new Sprite_Character($gamePlayer));
            SceneManager._scene._created = 1;
        }, frame);
        SceneManager._scene._requestWaitCreating = true;
        this.createPlayAnimationSprite();
    };
    
    var _Scene_Map_isReady = Scene_Map.prototype.isReady;
    Scene_Map.prototype.isReady = function() {
        if (this._created === 0) {
        } else if (this._created >= 1) {
            if (++this._created >= 30) {
                $gameMap.rejudgeEvents();
                this._requestWaitCreating = false;
                return true;
            }
        } else if (_Scene_Map_isReady.apply(this, arguments)) {
            if (this._requestWaitCreating) this._created = 0;
            else return true;
        }
        return false
    };
    
    Spriteset_Map.prototype.refreshChildCharacters = function() {
        this._characterSprites.forEach(function(sprite) {
            var ch = sprite._character;
            if (sprite._drawed) {
                this._tilemap.removeChild(sprite);
                if (sprite._hpGaugeSprite) this._baseSprite.removeChild(sprite._hpGaugeSprite);
                if (sprite._shadowSprite) this._tilemap.removeChild(sprite._shadowSprite);
            }
            if (!ch || !ch._eventId || !ch.needNotSprite()) {
                if (sprite._shadowSprite) this._tilemap.addChild(sprite._shadowSprite);
                if (sprite._hpGaugeSprite) this._baseSprite.addChild(sprite._hpGaugeSprite);
                this._tilemap.addChild(sprite);
                sprite._drawed = true;
            } else {
                sprite.opacity = 0;
                sprite._drawed = false;
            }
        }, this);
        this._tilemap._sortChildren();
//        $gameSystem.display(this.children.length,0,0,0,0,1);
    };

    var __Spriteset_Map_update = Spriteset_Map.prototype.update;
    Spriteset_Map.prototype.update = function() {
        __Spriteset_Map_update.apply(this, arguments);
        var info = [$gameMap.displayX(), $gameMap.displayY()];
        if (!this._lastPlayerXyInfo ||
            Math.abs(this._lastPlayerXyInfo[0] - info[0]) >= 2 ||
            Math.abs(this._lastPlayerXyInfo[1] - info[1]) >= 2)
        {
            this._lastPlayerXyInfo = info;
            this.refreshChildCharacters();
        }
    };

    var _Game_Map_refresh = Game_Map.prototype.refresh;
    Game_Map.prototype.refresh = function() {
        _Game_Map_refresh.apply(this, arguments);
//        SceneManager._scene._spriteset._lastPlayerXyInfo = null;
//        $gameMap._lastPlayerXyInfo = null;
    };
    
    //メモリリーク防止用
    var _DataManager_loadMapData = DataManager.loadMapData;
    DataManager.loadMapData = function(mapId) {
        if ($dataMap) $dataMap = null;
        _DataManager_loadMapData.apply(this, arguments);
    };
    
})();
