//=============================================================================
// KNH_Template.js
//=============================================================================

/*:
 * @plugindesc タイトル(日本語)
 * @author こんにちは
 *
 * @version 1.0.0 2017/10/27 公開
 *
 * @param パラメータ1
 * @desc 1行目
 * 2行目
 * @default 
 *
 * @param パラメータ2
 * @desc 1行目
 * 2行目
 * @default 
 *
 * @param パラメータ3
 * @desc 1行目
 * 2行目
 * @default 
 *
 * @help へるぷ
 *
 * デプロイメント時の「未使用ファイルを含まない」で消去されないよう
 * 注意してください。
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 * ●プラグインコマンド
 *  【】内を入力してください。「\v[1]」等使用できます。
 *
 * 【コンソール あああ】  console.log('あああ')を実行
 * 【文章 あああ】  文章の表示で「あああ」と表示する
 *
 * ●スクリプト(上級者向け)
 *  【】内を入力してください。「\v[1]」等使用できます。
 *
 * ●利用規約
 *   特に無いです。
 */

(function() {
    'use strict';
    var pluginName = 'KNH_Template';
    
    var getBoolean = function(text) {
        return (applyCharacters(text) || '').toUpperCase() === 'ON';
    };
    
    var getNumber = function(text, max, min) {
        text = applyCharacters(text);
        if (isNaN(text)) return NaN;
        return Math.max(Math.min(Number(text), max || Infinity), min || -Infinity);
    };
    
    var getArrayString = function(text) {
        var values = applyCharacters(text).split(',');
        for (var i = 0; i < values.length; i++) {
            values[i] = values[i].trim();
            if (!isNaN(values[i])) values[i] = Number(values[i]);
        }
        return values;
    };
    
    var applyCharacters = function(text) {
        if (text === null) text = '';
        text = '' + text;
        text = text.replace(/\\/g, '\x1b');
        text = text.replace(/\x1b\x1b/g, '\\');
        text = text.replace(/\x1bV\[(\d+)\]/gi, function() {
            return $gameVariables.value(parseInt(arguments[1], 10));
        }.bind(this));
        text = text.replace(/\x1bV\[(\d+)\]/gi, function() {
            return $gameVariables.value(parseInt(arguments[1], 10));
        }.bind(this));
        text = text.replace(/\x1bN\[(\d+)\]/gi, function() {
            var actor = parseInt(arguments[1], 10) >= 1 ? $gameActors.actor(parseInt(arguments[1], 10)) : null;
            return actor ? actor.name() : '';
        }.bind(this));
        text = text.replace(/\x1bP\[(\d+)\]/gi, function() {
            var actor = parseInt(arguments[1], 10) >= 1 ? $gameParty.members()[parseInt(arguments[1], 10) - 1] : null;
            return actor ? actor.name() : '';
        }.bind(this));
        if ($dataSystem) text = text.replace(/\x1bG/gi, TextManager.currencyUnit);
        return text;
    };
    
    var getMeta = function(text, str) {
        var re = /<([^<>:]+)(:?)([^>]*)>/g;
        var meta = {};
        for (;;) {
            var match = re.exec(text);
            if (match) {
                if (match[2] === ':') {
                    meta[match[1]] = match[3];
                } else {
                    meta[match[1]] = true;
                }
            } else {
                break;
            }
        }
        return meta['' + str];
    }
    
    //-----------------------------------------------------------------------------
    // プラグインパラメータの取得
    //-----------------------------------------------------------------------------
    
    var param = function(paramName) {
        return PluginManager.parameters(pluginName)[paramName];
    };
    
    var paramText = function(paramName) {
        return applyCharacters(PluginManager.parameters(pluginName)[paramName]);
    };

    var paramBoolean = function(paramName) {
        return getBoolean(paramText(paramName));
    };
    
    var paramNumber = function(paramName, max, min) {
        return getNumber(paramText(paramName), max, min);
    };
    
    var paramArrayString = function(paramName) {
        return getArrayString(paramText(paramName));
    };

    var param1 = paramNumber('パラメータ1');
    var param2 = paramBoolean('パラメータ2');
    var param3 = paramArrayString('パラメータ3');
    
    //-----------------------------------------------------------------------------
    // プラグインコマンドの追加
    //-----------------------------------------------------------------------------
    
    var _Game_Interpreter_pluginCommand      = Game_Interpreter.prototype.pluginCommand;
    Game_Interpreter.prototype.pluginCommand = function(command, args) {
        _Game_Interpreter_pluginCommand.call(this, command, args);
        try {
            this.pluginCommandTemplate(command, args);
        } catch (e) {
            if ($gameTemp.isPlaytest() && Utils.isNwjs()) {
                var window = require('nw.gui').Window.get();
                if (!window.isDevToolsOpen()) {
                    var devTool = window.showDevTools();
                    devTool.moveTo(0, 0);
                    devTool.resizeTo(Graphics.width, Graphics.height);
                    window.focus();
                }
            }
            console.log('プラグインコマンドの実行中にエラーが発生しました。');
            console.log('- コマンド名 　: ' + command);
            console.log('- コマンド引数 : ' + args);
            console.log('- エラー原因   : ' + e.toString());
        }
    };
    
    Game_Interpreter.prototype.pluginCommandTemplate = function(command, args) {
        var text;
        switch (command) {
            case 'コンソール':
                text = applyCharacters(args[0]);
                console.log(text);
                break;
            case '文章':
                text = applyCharacters(args[0]);
                $gameMessage.add(text);
                break;
        }
    };

    //-----------------------------------------------------------------------------
    // Scene_Map
    //-----------------------------------------------------------------------------
    var _Scene_Map_start = Scene_Map.prototype.start;
    Scene_Map.prototype.start = function() {
        _Scene_Map_start.call(this);
        console.log(param1);
        console.log(param2);
        console.log(param3);
        console.log($dataSystem);
    };
    
})();
